# GeoPops
**Full documentation and tutorials coming soon!**
GeoPops is in development, and we welcome feedback. Please log any issues.

**GeoPops** is a package for generating geographically and demographically realistic synthetic populations for any US Census location using publically available data. Population generation includes three steps:
1. Generate individuals and households using combinatorial optimization (CO)
2. Assign individuals to school and workplace locations using enrollment data and commute flows
3. Connect individuals within locations using graph algorithms

Resulting files include a list of agents with attributes (e.g., age, gender, income) and networks detailing their connections within home, school, workplace, and group quarters (e.g., correctional facilities, nursing homes) locations. GeoPops is meant to produce reasonable approximations of state and county population characteristics with granularity down to the Census Block Group (CBG).   GeoPops builds on a previous package, [GREASYPOP-CO](https://github.com/CDDEP-DC/GREASYPOP-CO/tree/main) (One Health Trust), and incorporates the following changes:
- All code wrapped in convenient Python package that can be pip installed
- Compatibility with Census data beyond 2019 (still developing)
- Automated data downloading
- Users can adjust all config parameters from the front-end
- Class for exporting files compatible with the agent-based modeling software [Starsim](https://starsim.org/) (Institute for Disease Modeling)

There are many packages for generating agents and households from Census data, but GeoPops is the only one that is completely open source and generalizable that spatially connects agents in school and workplace networks. In combination with agent-based modeling tools like Starsim, GeoPops can facilitate timely context-specific scenario modeling of respiratory infectious diseases.

## Get involved
GeoPops is in development and we welcome feedback! Get in touch if you've tried making a population of your own or want to become a member. You can upload your own example as a respository in the [GeoPopsHub](https://github.com/GeoPopsHub).

## Tutorial
See the repo [sc_spartanburg_measles](https://github.com/GeoPopsHub/sc_spartanburg_measles) for a detailed example of how to build a population, simulate a disease, test out interventions, and track outcomes by subgroup. [`1_run_geopops.ipynb`](https://github.com/GeoPopsHub/sc_spartanburg_measles/blob/main/1_run_geopops.ipynb) has instructions on how to build a GeoPops population.

## Support
GeoPops is a collaboration between the following institutions:
* [ACCIDDA](https://accidda.org/)
* [Insight Net](https://insightnet.us/)
* [Johns Hopkins University Center for Systems Science and Engineering](https://systems.jhu.edu/)
* [One Health Trust](https://onehealthtrust.org/)
* [Institute for Disease Modeling](https://www.idmod.org/)
* [Johns Hopkins University Applied Physics laboratory](https://www.jhuapl.edu/)
* [University of Virginia](https://www.virginia.edu/)

#=
Copyright 2023 Alexander Tulchinsky

This file is part of Greasypop.

Greasypop is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Greasypop is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License along with Greasypop. If not, see <https://www.gnu.org/licenses/>.
=#

using StatsBase
using InlineStrings
using SparseArrays

## may change these
const CBGkey = UInt16
const Hnum = UInt16
const Pnum = UInt32
const Hkey = Tuple{Hnum,CBGkey}
const Pkey = Tuple{Pnum,Hnum,CBGkey}
const GQkey = Tuple{UInt16,CBGkey}
const WRKkey = Tuple{UInt32, UInt8, String31}

struct PersonData
    hh::Hkey
    sample::UInt32
    age::Int16
    working::Bool
    commuter::Bool
    com_cat::Union{Missing,UInt8} ## wp category (industry, etc) for placing commuters in wp's 
    com_inc::Union{Missing,UInt8} ## income category for commuters, to make wp contact networks
    sch_grade::Union{Missing,String3}
    #more_traits::Dict{Symbol,Union{Missing,Bool}}
    ## ^^ that would be nice, but several million dicts will use a lot of memory, so...
    ## (these have to be in the same order as "additional traits" in config.json)
    sch_public::Union{Missing,Bool}
    sch_private::Union{Missing,Bool}
    female::Union{Missing,Bool}
    race_black_alone::Union{Missing,Bool}
    white_non_hispanic::Union{Missing,Bool}
    hispanic::Union{Missing,Bool}
end

struct Household
    sample::UInt32
    people::Vector{Pkey}
end

struct GQres
    type::Symbol
    residents::Vector{Pkey}
end

## make dicts callable, with a closure to handle missing keys
(d::AbstractDict)(x,f::Base.Callable) = get(f,d,x)

## subset of dict by keys
dsubset(d::Dict{K,V},s) where {K<:Any,V<:Any} = Dict{K,V}(k=>d[k] for k in intersect(keys(d),s))

mutable struct Indexer{I}
    i::I
end
## constructor
Indexer{T}() where {T<:Number} = Indexer(zero(T))
## an indexer object functions like a closure
## when called with a dict and key, returns that key's index,
## inserts the key with a new index if it doesn't exist
function (ix::Indexer{I})(d::Dict{K,I}, k::K) where {I<:Number, K<:Any}
    if haskey(d,k)
        return d[k]
    else
        ix.i += 1
        d[k] = ix.i
        return ix.i
    end
end

## convert to integer, missing becomes 0
int(x::T) where T<:Real = round(Int64, x)
int(x::Missing) = Int64(0)

## convert x to type T, missing stays missing
mcon(::Type{T}, x::Missing) where {T<:Any} = missing
mcon(::Type{T}, x::U) where {T,U} = convert(T,x)::T

## convert missing bool to false
mtrue(x::Union{Missing,Bool}) = coalesce(x,false)

## filter dict on values
filterv(f, d::Dict) = filter( ((k,v),) -> f(v) , d)

## filter dict on keys
filterk(f, d::Dict) = filter( ((k,v),) -> f(k) , d)

## merge two dictionaries with vector values
vecmerge = mergewith(vcat)
## as above, but modifies the first dict in-place
vecmerge! = mergewith!(vcat)

## "flattens" a dictionary whose values are vectors/collections
## returns a vector of pairs
dflat(d::Dict) = collect(Iterators.flatmap(x->((x.first => y) for y in x.second), d))

## continuous index ranges with lengths given by vec
function ranges(vec::Vector{I}) where {I<:Integer}
    x = cumsum(vec)
    return [a:b for (a,b) in zip([1;x[1:end-1].+1], x)]
end

## returns first nonempty member of v
function first_nonempty(v) 
    i = findfirst(!isempty, v)
    isnothing(i) ? empty(v) : v[i]
end

## index of first true in v, otherwise missing
first_true(v) = something(findfirst(v),missing)

## replace values less than threshhold with 0
thresh(x,v) = x < v ? zero(x) : x

## random lognormal
rlogn(mu::T, sigma::T) where T<:Real = exp(mu + sigma*randn())

## round a vector to integers while preserving sum
## (using largest-remainder method)
function lrRound(v::AbstractVector{T}) where T<:Real
    vrnd = floor.(Int64, v)
    verr = v .- vrnd
    vrem = round(Int64, sum(v) - sum(vrnd))
    vidxs = sortperm(verr, rev=true)
    for i in 1:vrem
        vrnd[vidxs[i]] += 1    
    end
    return vrnd    
end

## make it work with matrices too
function lrRound(v::AbstractMatrix{T}) where T<:Real
    orig_dims = size(v)
    vrnd = lrRound(vec(v))
    return reshape(vrnd, orig_dims)
end

## but round each row
function rowRound(m::AbstractMatrix{T}) where T<:Real
    res = zeros(Int,size(m))
    for i in axes(m,1)
        res[i,:] = lrRound(m[i,:])
    end
    return res
end

## but round each column
function colRound(m::AbstractMatrix{T}) where T<:Real
    res = zeros(Int,size(m))
    for i in axes(m,2)
        res[:,i] = lrRound(m[:,i])
    end
    return res
end

## sample from a vector of counts; returns an index and depletes the counts
##    "AbstractArray" means this also works on 1D _views_ of a matrix
function drawCounts!(v::AbstractArray{I}) where {I<:Integer}
    i = wsample(eachindex(v),v) ## wsample() from StatsBase
    v[i] -= 1 ## modify v
    return i
end

## sample n from a vec of counts; returns vec of indices and depletes counts
function drawCounts!(v::AbstractArray{Ia}, n::Ib) where {Ia<:Integer,Ib<:Integer}
    ## should probably throw an error if n > sum(v)
    n = min(n,sum(v))
    res = zeros(Int64, n)
    for i in 1:n
        res[i] = drawCounts!(v)
    end
    return res
end

#=
Copyright 2023 Alexander Tulchinsky

This file is part of Greasypop.

Greasypop is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Greasypop is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License along with Greasypop. If not, see <https://www.gnu.org/licenses/>.
=#

#using Distributed
using Random
using Graphs
#using GraphPlot
using SparseArrays
using LinearAlgebra
using SharedArrays
using Distributions
using Plots
using StatsPlots
using StatsBase


#using MatrixDepot
#using SNAPDatasets

include("utils.jl")
include("fileutils.jl")


##
## network stats
##

## from Bonchev 2004, Ir(vd)
function Bonchev_vd_info0(t::AbstractGraph{T}) where T
    v = filter(x->x>0,degree(t))
    A = sum(v)
    return (sum( v .* log2.(v) )) / ( A * log2(A) )
end

function Bonchev_vd_info(t::AbstractGraph{T}) where T
    v = filter(x->x>0,degree(t))
    A = sum(v)
    return sum(  v .* log2.(v) ./ (A * log2(A)) ) 
end

## from Saberi 2021
makehub(t::AbstractGraph{T}) where T = sum(degree(t) .^ 2) / sum(degree(t))





#g = watts_strogatz(100,8,0.25)
#gplot(g)
## simulate infection at p = ?
#diffusion_rate(g, 0.5, 10)
## mean path length
#f = floyd_warshall_shortest_paths(g)
#sum(f.dists) / length(f.dists)

## neighbors
#g = watts_strogatz(20,6,0.3)
#[neighbors(g,x) for x in vertices(g)]


#include("netw.jl")

#generate_network()

#full_mat, full_keys = sparse_from_adjdict(merge_hh_net());
#ser_path("jlse/full_graph_mat.jlse", sparse(UpperTriangular(full_mat)))
#ser_path("jlse/full_graph_keys.jlse", full_keys)


## note this method adds zero-degree vertices if adj_mat has 0-sum rows
#full_graph = SimpleGraph(sparse(Symmetric(dser_path("jlse/full_graph_mat.jlse"))))
#ser_path("jlse/full_graph.jlse",full_graph)

#full_graph = dser_path("jlse/full_graph.jlse")
#node_keys = dser_path("jlse/full_graph_keys.jlse")



#f(v) = mean(v[2:end] ./ v[1:end-1])


#net_comp = Dict()
net_comp = dser_path("net_comp.jlse")

#M = sparse(Symmetric(dser_path("jlse/hh_adj_mat.jlse"))) .| sparse(Symmetric(dser_path("jlse/adj_mat.jlse")))
#M = dser_path("jlse/hh_adj_mat.jlse") .| dser_path("jlse/adj_mat.jlse")

x = (Edge(p) for p in zip(findnz(
    dser_path("jlse/adj_mat_hh.jlse") .| dser_path("jlse/adj_mat_non_hh.jlse")
    )[1:2]...))

t = SimpleGraphFromIterator(x)
x = nothing
GC.gc()

N = nv(t)  # 9424031
n0 = sum(degree(t).==0)  # 401057
mu = mean(degree(t)) ## 8.483098686750925
nname = "MD"

#N - n0
#mean(filter(i->i>0,degree(t)))
#deg_zero_i = findall(degree(t).==0)
#rem_vertices!(t, deg_zero_i)
#nv(t)
#mean(degree(t))
#nname = "MD0"


## "static scale free" algo 
## Goh K-I, Kahng B, Kim D: Universal behaviour of load distribution in scale-free networks. Phys Rev Lett 87(27):278701, 2001.

t = nothing
GC.gc()
t = barabasi_albert(N, 4); nname = "BA"
t = erdos_renyi(N, mu/N); nname = "ER"
t = watts_strogatz(N, 8, 0.25); nname = "WS"
t = static_scale_free(N, round(Int,0.5*mu*N), 3); nname = "SSF"
mean(degree(t))



net_comp[nname] = [mean(local_clustering_coefficient(t))
global_clustering_coefficient(t)
mean(pagerank(t))
rich_club(t,1)
assortativity(t)
Bonchev_vd_info(t)
makehub(t)
mean(degree(t))
#mean(f(diffusion_rate(t,0.1,20)) for x in 1:20)
]

net_comp

ser_path("net_comp.jlse", net_comp)

nc_names = ["local clust","global clust","pagerank","rich club","assortativity","bonchev","makehub","mean degree"]
use_cols = [8,1,2,5,7,6]
[nc_names[x] for x in use_cols]
[k=>[round(v[x];sigdigits=3) for x in use_cols] for (k,v) in net_comp]






#adj_n0 = false
#if adj_n0
#    for x in shuffle(vertices(t))[1:n0]
#        for d in neighbors(t,x)
#            rem_edge!(t,x,d)
#        end
#    end
#end
#mean(degree(t))



m = matrixdepot("SNAP/loc-Gowalla")
t = SimpleGraph(m)
net_comp["loc_gowalla"] = [mean(local_clustering_coefficient(t))
global_clustering_coefficient(t)
mean(pagerank(t))
rich_club(t,1)
assortativity(t)
Bonchev_vd_info(t)
makehub(t)
mean(degree(t))
#mean(f(diffusion_rate(t,0.1,20)) for x in 1:20)
]

m = matrixdepot("SNAP/loc-Brightkite")
t = SimpleGraph(m)
net_comp["loc_brightkite"] = [mean(local_clustering_coefficient(t))
global_clustering_coefficient(t)
mean(pagerank(t))
rich_club(t,1)
assortativity(t)
Bonchev_vd_info(t)
makehub(t)
mean(degree(t))
#mean(f(diffusion_rate(t,0.1,20)) for x in 1:20)
]

m = matrixdepot("Newman/as-22july06")
t = SimpleGraph(m)
net_comp["routers"] = [mean(local_clustering_coefficient(t))
global_clustering_coefficient(t)
mean(pagerank(t))
rich_club(t,1)
assortativity(t)
Bonchev_vd_info(t)
makehub(t)
mean(degree(t))
#mean(f(diffusion_rate(t,0.1,20)) for x in 1:20)
]

m = matrixdepot("Barabasi/NotreDame_yeast")
t = SimpleGraph(m)
net_comp["yeast"] = [mean(local_clustering_coefficient(t))
global_clustering_coefficient(t)
mean(pagerank(t))
rich_club(t,1)
assortativity(t)
Bonchev_vd_info(t)
makehub(t)
mean(degree(t))
#mean(f(diffusion_rate(t,0.1,20)) for x in 1:20)
]

m = matrixdepot("DIMACS10/coPapersDBLP")
t = SimpleGraph(m)
net_comp["citation_dblp"] = [mean(local_clustering_coefficient(t))
global_clustering_coefficient(t)
mean(pagerank(t))
rich_club(t,1)
assortativity(t)
Bonchev_vd_info(t)
makehub(t)
mean(degree(t))
#mean(f(diffusion_rate(t,0.1,20)) for x in 1:20)
]

m = matrixdepot("SNAP/com-DBLP")
t = SimpleGraph(m)
net_comp["com_dblp"] = [mean(local_clustering_coefficient(t))
global_clustering_coefficient(t)
mean(pagerank(t))
rich_club(t,1)
assortativity(t)
Bonchev_vd_info(t)
makehub(t)
mean(degree(t))
#mean(f(diffusion_rate(t,0.1,20)) for x in 1:20)
]

ser_path("jlse/net_comp.jlse",net_comp)


t = SimpleGraph(sparse(matrixdepot("SNAP/com-Orkut")))
net_comp["com_orkut"] = [mean(local_clustering_coefficient(t))
global_clustering_coefficient(t)
mean(pagerank(t))
rich_club(t,1)
assortativity(t)
Bonchev_vd_info(t)
makehub(t)
mean(degree(t))
#mean(f(diffusion_rate(t,0.1,20)) for x in 1:20)
]

ser_path("jlse/net_comp.jlse",net_comp)
t = nothing
GC.gc()

t = SimpleGraph(sparse(matrixdepot("SNAP/com-Amazon")))
net_comp["com_amazon"] = [mean(local_clustering_coefficient(t))
global_clustering_coefficient(t)
mean(pagerank(t))
rich_club(t,1)
assortativity(t)
Bonchev_vd_info(t)
makehub(t)
mean(degree(t))
#mean(f(diffusion_rate(t,0.1,20)) for x in 1:20)
]

ser_path("jlse/net_comp.jlse",net_comp)
t = nothing
GC.gc()

t = SimpleGraph(sparse(matrixdepot("SNAP/com-Youtube")))
net_comp["com_youtube"] = [mean(local_clustering_coefficient(t))
global_clustering_coefficient(t)
mean(pagerank(t))
rich_club(t,1)
assortativity(t)
Bonchev_vd_info(t)
makehub(t)
mean(degree(t))
#mean(f(diffusion_rate(t,0.1,20)) for x in 1:20)
]

ser_path("jlse/net_comp.jlse",net_comp)
t = nothing
GC.gc()

t = SimpleGraph(sparse(matrixdepot("SNAP/com-LiveJournal")))
net_comp["com_liveJournal"] = [mean(local_clustering_coefficient(t))
global_clustering_coefficient(t)
mean(pagerank(t))
rich_club(t,1)
assortativity(t)
Bonchev_vd_info(t)
makehub(t)
mean(degree(t))
#mean(f(diffusion_rate(t,0.1,20)) for x in 1:20)
]

ser_path("jlse/net_comp.jlse",net_comp)
t = nothing
GC.gc()


#m = matrixdepot("SNAP/p2p-Gnutella08")
#t = SimpleDiGraph(m)
#m = matrixdepot("SNAP/email-Eu-core")
#t = SimpleDiGraph(m)

#t = loadsnap(:ca_astroph)
#t = loadsnap(:ego_twitter_u)
#t = loadsnap(:email_enron)
#t = loadsnap(:facebook_combined)
#t = loadsnap(:soc_slashdot0902_u)

#net_comp = dser_path("jlse/net_comp.jlse")

mask = BitVector([1,1,0,0,1,0])
y = reduce(hcat, net_comp[k][mask] for k in
    ["LA_full","small_world","scale_free","p2p","email","ca_astroph",
    "ego_twitter_u","email_enron","facebook_combined","soc_slashdot0902_u"])
shapes = ([[:star4, :circle, :circle]; fill(:+,7)])

plot([1:3], y, shape=reshape(shapes,1,10),
    label="", xticks=:none, 
    linestyle=:dash, linealpha=0.5)



##
## checking fit of synth pop
##

FTdist(v1::Matrix{T},v2::Matrix{T}) where T<:Real = sum((sqrt.(v1 .+ one(T)) .- sqrt.(v2 .+ one(T))) .^ 2)
summarize(idxs::Vector{Int64}, pop::Matrix{Int64}) = sum(view(pop,idxs,:), dims=1)
function summarize!(dest::Matrix{Int64}, idxs::Vector{Int64}, pop::Matrix{Int64})
    sum!(dest, view(pop,idxs,:))
    return nothing
end

## rmse standardized by st dev
SRMSE(O::Vector{T},E::Vector{T}) where T<:Real =  sqrt(mean((O .- E) .^ 2)) / std(E)

function read_test_targs()
	acs_targets = read_df("processed/test_targets.csv"; types=Dict("Geo"=>String15))
    targ_idxs = axes(acs_targets,1)
	targs = [Matrix{Int64}(acs_targets[[targ_id],2:end]) for targ_id in targ_idxs]
	geos = [acs_targets[targ_id,1] for targ_id in targ_idxs]
	return (targs, geos, names(acs_targets)[2:end])
end

function read_test_samples()
	puma_samples_all = read_df("processed/test_samples.csv"; types=Dict("SERIALNO"=>String15))
	hh_ids = puma_samples_all[:,1] ## for looking up the household serial numbers later
	shared_samples = Matrix{Int64}(puma_samples_all[:,2:end])
	return (shared_samples, hh_ids)	
end

function calc_test_scores()
    targs_all, geos_all, targ_colnames = read_test_targs()
    samples, hh_ids = read_test_samples()
    hh_idx = Dict(hh_ids .=> eachindex(hh_ids))
    ## each target's county
    county = [g[1:5] for g in geos_all]
    counties = unique(county)
    summary = similar(first(targs_all))

    for c in counties
        cbg_hhs = dser_path("jlse/CO/hh"*c*".jlse");        
        targs = targs_all[county .== c]
        geos = geos_all[county .== c]
        targ_idx = Dict(geos .=> eachindex(geos))
        test_scores = Dict{String15,Float64}()
        for (cbg,households) in cbg_hhs
            summarize!(summary, [hh_idx[k] for k in households], samples)
            test_scores[cbg] = FTdist(summary, targs[targ_idx[cbg]])
        end
        ser_path("jlse/CO/test_"*c*"_scores.jlse",test_scores)
    end
end



## targets are census block group (cbg) summary statistics
function read_targets(targ_idxs=[])
	acs_targets = read_df("processed/acs_targets.csv"; types=Dict("Geo"=>String15))
	if isempty(targ_idxs)
		targ_idxs = axes(acs_targets,1)
	end
	## pull target stats from the dataframe and convert to matrix or array for faster math 
	targs = [Matrix{Int64}(acs_targets[[targ_id],2:end]) for targ_id in targ_idxs]
	geos = [acs_targets[targ_id,1] for targ_id in targ_idxs]
	return (targs, geos, names(acs_targets)[2:end])
end

## returns a sharedmatrix of samples -- can pass it to local parallel processes without copying data
function read_samples()
	puma_samples_all = read_df("processed/census_samples.csv"; types=Dict("SERIALNO"=>String15))
	hh_ids = puma_samples_all[:,1] ## for looking up the household serial numbers later
	shared_samples = Matrix{Int64}(puma_samples_all[:,2:end])
	return (shared_samples, hh_ids)	
end


function all_summaries(test::Bool)
    if test
        targs_all, geos_all, targ_colnames = read_test_targs()
        samples, hh_ids = read_test_samples()
    else
        targs_all, geos_all, targ_colnames = read_targets()
        samples, hh_ids = read_samples()
    end

    hh_idx = Dict(hh_ids .=> eachindex(hh_ids))
    county = [g[1:5] for g in geos_all]
    counties = unique(county)
    summary = similar(first(targs_all))
    summaries = Dict{String15, typeof(summary)}()

    for c in counties
        cbg_hhs = dser_path("jlse/CO/hh"*c*".jlse")
        for (cbg,households) in cbg_hhs
            summarize!(summary, [hh_idx[k] for k in households], samples)
            summaries[cbg] = copy(summary)
        end
    end
    
    t_mat = zeros(length(targs_all), length(first(targs_all)))
    for (i,r) in enumerate(targs_all)
        t_mat[i,:] = r
    end
    
    s_mat = zeros(length(summaries), length(first(values(summaries))))
    for (i,g) in enumerate(geos_all)
        s_mat[i,:] = summaries[g]
    end
    
    return s_mat, t_mat, geos_all, targ_colnames
end


s_mat, t_mat, geos_all, targ_colnames = all_summaries(false)
err_by_targ = [(n, SRMSE(s_mat[:,i],t_mat[:,i])) for (i,n) in enumerate(targ_colnames)]

s_mat, t_mat, geos_all, targ_colnames = all_summaries(true)
err_by_testvar = [(n, SRMSE(s_mat[:,i],t_mat[:,i])) for (i,n) in enumerate(targ_colnames)]

y = [[x[2] for x in err_by_targ]; [x[2] for x in err_by_testvar]]
scatter(y, label="", xticks=:none)


scatter([x[2] for x in err_by_targ], label="", xticks=:none)
[(x[1],x[2]) for x in err_by_targ if x[2]>0.3]

[(x[1],x[2]) for x in err_by_testvar if x[2]<0.4]

function random_answer(glob_samp_ref::Matrix{Int64}, mask::BitVector, targ::Matrix{Int64}, n::Int64, params::Dict{Symbol, R}) where R<:Real
    samples = glob_samp_ref[mask, :]
    idxs = axes(samples,1) 
    ## if no valid samples, return a bad score (this shouldn't happen)
    if isempty(idxs)
        return (Vector{Int64}(), 0, Inf, 0.0)
    end
    c0 = rand(idxs,n)
    summary = summarize(c0, samples)
    E0 = FTdist(summary, targ)
    res = findall(mask)[c0]
    return (res, 0, E0, 0.0)
end

function random_answerer(shared_samples::Matrix{Int64}, params::Dict{Symbol, R}) where R<:Real
    function f(mask::BitVector, targ::Matrix{Int64}, n::Int64)
        return random_answer(shared_samples, mask, targ, n, params)
    end
    return f
end

## number of households in each cbg
function read_hh_counts()
	hhcdf = read_df("processed/hh_counts.csv"; types=Dict("Geo"=>String15))
	## convert to dicts for easier lookup
	##  note the .=> syntax; this broadcasts associations between two arrays, similar to dict(zip()) in python
	return Dict(hhcdf[:,1] .=> hhcdf[:,2])
end

## geographic data for target cbg's -- will use these to determine which samples to use
function read_targ_geo()
	cbg_geo_cols = Dict("Geo"=>String15,"st_puma"=>String7,"cbsa"=>String7,"county"=>String7,"R"=>Float64,"U"=>Float64)
	cbg_geo = read_df("processed/cbg_geo.csv"; select=collect(keys(cbg_geo_cols)), types=cbg_geo_cols)
	cbg_puma = Dict(cbg_geo[:,"Geo"] .=> cbg_geo[:,"st_puma"])
	cbg_county = Dict(cbg_geo[:,"Geo"] .=> cbg_geo[:,"county"])
	cbg_cbsa = Dict(cbg_geo[:,"Geo"] .=> cbg_geo[:,"cbsa"])
	cbg_urban = Dict(cbg_geo[:,"Geo"] .=> cbg_geo[:,"U"])
	return (cbg_puma, cbg_county, cbg_cbsa, cbg_urban)
end

## looks up which samples in df to use, based on column name k and associated geo data of targets
## don't usually need to specify function return types but in this case, target_geo_codes might be empty and 
##   this way it still returns a vector{BitVector}
function sample_lookup(df::DataFrame, k::Symbol, target_geo_codes)::Vector{BitVector}
	if k == :U
		return [urbanization_lookup(df,x) for x in target_geo_codes]
	else
		## note .== syntax for element-wise comparison
		return [coalesce.(df[!,k] .== x, false) for x in target_geo_codes]
	end
end

## creates annealing function and executes it on available processors
## returns a vector of whatever anneal() returns
function dont_optimize(samples::Matrix{Int64}, samp_masks::Vector{BitVector}, targs::Vector{Matrix{Int64}}, n_hhs::Vector{Int64}, params)
	a_fn = random_answerer(samples, params)
	return map(a_fn, samp_masks, targs, n_hhs)
end

## performs several optimization runs on the target cbg's in each county
## writes each county's results to a separate file
function process_counties(test::Bool)

    if test
        samples, hh_ids = read_test_samples()
        targs_all, geos_all, targ_colnames = read_test_targs()
    else
    	samples, hh_ids = read_samples()
        targs_all, geos_all, targ_colnames = read_targets()
    end

	cbg_puma, cbg_county, cbg_cbsa, cbg_urban = read_targ_geo()
	samp_geo_cols = Dict("SERIALNO"=>String15,"st_puma"=>String7,"cbsa"=>String7,"county"=>String7,"R"=>Float64,"U"=>Float64)
	samp_geo = read_df("processed/samp_geo.csv"; select=collect(keys(samp_geo_cols)), types=samp_geo_cols)
	hh_counts = read_hh_counts()
	n_hhs_all = [hh_counts[g] for g in geos_all]
	county = [g[1:5] for g in geos_all]

	params = Dict(:maxgens => 0, :critval => 0.0, :cooldown => 0.0, :report => 0)

    counties = unique(county)
	for c in counties
		targs = targs_all[county .== c]
		geos = geos_all[county .== c]
		n_hhs = n_hhs_all[county .== c]

		## look up samples for each target based on target's puma code
		## puma is the most local sample level, has the fewest samples available
		samp_masks = sample_lookup(samp_geo, :st_puma, [cbg_puma[g] for g in geos])
		x = dont_optimize(samples, samp_masks, targs, n_hhs, params)

		## store results as dict keyed by cbg code; look up actual hh id's of sample indices
		scores = Dict(geos .=> [a[3] for a in x])
		households = Dict(geos .=> [hh_ids[a[1]] for a in x])

        if test
            ser_path("jlse/CO/rand_test_"*c*".jlse",households)
            ser_path("jlse/CO/rand_test_"*c*"_scores.jlse",scores)
        else
            ser_path("jlse/CO/rand_"*c*".jlse",households)
            ser_path("jlse/CO/rand_"*c*"_scores.jlse",scores)
        end
	end

	return nothing
end

calc_test_scores()
process_counties(true)
process_counties(false)

geos = read_targ_geo()
counties = unique(values(geos[2]))

x = [dser_path("jlse/CO/test_"*c*"_scores.jlse") for c in counties]
test_scores = merge(x...)
x = [dser_path("jlse/CO/hh"*c*"_scores.jlse") for c in counties]
scores = merge(x...)
x = [dser_path("jlse/CO/rand_"*c*"_scores.jlse") for c in counties]
rand_scores = merge(x...)
x = [dser_path("jlse/CO/rand_test_"*c*"_scores.jlse") for c in counties]
rand_test_scores = merge(x...)

cbgs = collect(keys(scores))

s05,s95 = log.(0.25 .* quantile.(Chisq(85), [0.05, 0.95]))
t05,t95 = log.(0.25 .* quantile.(Chisq(31), [0.05, 0.95]))

s1 = [scores[k] for k in cbgs]
s2 = [rand_scores[k] for k in cbgs]

t1 = [test_scores[k] for k in cbgs]
t2 = [rand_test_scores[k] for k in cbgs]

circ = Shape(Plots.partialcircle(0, 2π))
plot([log.(s1) log.(s2)], label="", xticks=:none, seriestype=:scatter, grid=false,
    ylims=(1.0,9.1),
    xlabel="census block group",ylabel="ln(¼ FT²)",
    markerstrokewidth=[0 0.5], markersize=[1.5 2.5], markercolor=[:black :white],
    markershape=[:none circ],markerstrokecolor=:black, markeralpha=[1.0 0.5],
    markerstrokealpha=[1.0 0.75],
    dpi=300)
hline!([s95], linecolor=:orangered, linestyle=:dash, label="")
hline!([t95], linecolor=:orangered, linestyle=:dash, label="")
savefig("scores-vs-rand.png")
savefig("test-vs-rand.png")



xlabels = ["optimized selection,\ntargeted variables" "random selection,\ntargeted variables"]
vals = [log.(s1) log.(s2)]
crit_val = s95

xlabels = ["optimized selection,\nuntargeted variables" "random selection,\nuntargeted variables"]
vals = [log.(t1) log.(t2)]
crit_val = t95


dotplot(xlabels, vals, label="",grid=false,ylabel="mismatch score",tick_direction=:out, 
    ylims=(1.0,9.1),
    markerstrokewidth=0, markersize=1.5, markercolor=:black, markershape=:none,
    markeralpha=0.5,
    dpi=300)

violin!(xlabels, vals, label="",
    fillalpha=0.0,linealpha=0.5,linewidth=0.5,linecolor=:black)

hline!([crit_val], linecolor=:orangered, linestyle=:dash, label="")

savefig("scores-vs-rand.png")
savefig("test-vs-rand.png")




## testing income segregated workplaces

cbg_idxs = dser_path("jlse/cbg_idxs.jlse")
hh = dser_path("jlse/hh.jlse")
gqs = dser_path("jlse/gqs.jlse")
people = dser_path("jlse/people.jlse")
df_gq_summary = dser_path("jlse/df_gq_summary.jlse")

length(values(people))
sum(p.working for p in values(people))
sum(p.commuter for p in values(people))
sum(p.com_LODES_low for p in values(people))
sum(p.com_LODES_high for p in values(people))
sum(coalesce(p.female,rand([true,false])) for p in values(people))
mean(p.age for p in values(people))

sum(df_gq_summary.noninst1864)
sum(df_gq_summary.working)
sum(df_gq_summary.not_working)
sum(df_gq_summary.commuter)
sum(df_gq_summary.wfh)
sum(df_gq_summary.com_LODES_low)
sum(df_gq_summary.com_LODES_high)

gq_ppl = [people[k] for k in reduce(vcat, [x.residents for x in values(gqs)])]
sum(df_gq_summary.instu18 + df_gq_summary.inst1864 + df_gq_summary.noninst1864 + df_gq_summary.inst65o)

sum(p.working for p in values(gq_ppl))
sum(p.commuter for p in values(gq_ppl))
sum(p.com_LODES_low for p in values(gq_ppl))
sum(p.com_LODES_high for p in values(gq_ppl))
mean(p.age for p in values(gq_ppl))

df = read_df("processed/work_od_matrix.csv"; types=Dict("h_cbg"=>String15))
df_noinc = read_df("processed/work_od_matrix_no_inc.csv"; types=Dict("h_cbg"=>String15))
df
df_noinc
df[!,:outside]
df_noinc[!, :outside]

hh_samps = read_df("processed/hh_samples.csv"; types=Dict("SERIALNO"=>String15))
hh_samps[:,
        [:SERIALNO,:NP,:HINCP,
        #:employed, :unemployed, :armed_forces, 
        :in_lf,
        :nilf, :work_from_home, :commuter, 
        #:worked_past_yr,
        :has_job,:com_LODES_low,:com_LODES_high]]

p_samps = read_df("processed/p_samples.csv"; types=Dict("SERIALNO"=>String15));
p_samps[: , [:SERIALNO,:WAGP,:PINCP,:PERNP,:COW,:ESR,:work_from_home,:commuter,:has_job,:com_LODES_low,:com_LODES_high]]






## testing stochastic block model

using Graphs
using GraphPlot
using LinearAlgebra

n_k = 2
mean_deg = 8
n1 = 18
n2 = 9
n_vec = [n1,n2]

w_planted = Diagonal(fill(mean_deg,n_k))
prop_i = n_vec ./ sum(n_vec)
w_random = repeat(transpose(prop_i) * mean_deg, n_k)

assoc_coeff = 0.9
c_matrix = assoc_coeff * w_planted + (1 - assoc_coeff) * w_random

## can't have more than n connections to a group
for r in eachrow(c_matrix)
    r .= min.(r,n_vec)
end
c_matrix

## can't have more than n-1 within-group connections
d_tmp = view(c_matrix, diagind(c_matrix))
d_tmp .= min.(d_tmp, n_vec .- 1)
c_matrix

## note, in a stochastic block model (SBM) the degree distribution within blocks is similar to 
##  a random (erdos-renyi) network. For a more realistic degree distribution (e.g., with hubs)
##  try a degree-corrected SBM (Karrer & Newman 2010, https://arxiv.org/abs/1008.3926)
g = stochastic_block_model(c_matrix,n_vec)
gplot(g)

## Graphs.jl sometimes creates 0-degree vertices but I don't think it should
fix_zeros = findall(degree(g).==0)
for x in fix_zeros
    add_edge!(g, x, rand(vertices(g)))
end

mean(degree(g))
mean(degree(g)[1:n1])
mean(degree(g)[(n1+1):end])

c_matrix

g2 = stochastic_block_model(reshape([8.0], 1, 1),[30])
gplot(g2)
mean(degree(g2))




## making sure all schools are getting students allocated 

sch_students = dser_path("jlse/sch_students.jlse")

schools = read_df("processed/schools.csv"; types=Dict("NCESSCH"=>String15))
distmat = read_df("processed/cbg_sch_distmat.csv"; types=Dict("GEOID"=>String15))
schools_idx = Dict(schools.NCESSCH .=> eachindex(schools.NCESSCH))
cap_by_school = Dict(k=>schools[schools_idx[k], "STUDENTS"] for (k,_) in sch_students)
n_students_by_school = Dict(k=>length(v) for (k,v) in sch_students)

sum(values(cap_by_school))
sum(values(n_students_by_school))
sum(values(n_students_by_school)) / sum(values(cap_by_school))

spots_left = Dict(k=>(cap_by_school[k]-n_students_by_school[k]) for (k,_) in sch_students)
p_filled = Dict(k=>(n_students_by_school[k] / cap_by_school[k]) for (k,_) in sch_students)
p_new = Dict(k=>(n_students_by_school[k] / cap_by_school[k]) for (k,_) in sch_students)

partialsort(collect(values(p_filled)),1:20)
partialsort(collect(values(p_new)),1:20)

sort(collect(values(p_filled)))[end-20:end]

using Plots
plot!(sort(collect(values(p_filled))))
plot!(sort(collect(values(p_new))))

sortperm(collect(values(p_filled)))
cap_by_school[collect(keys(p_filled))[601]]


## checking census data integrity

c10 = read_df("geo/2010_Census_Tract_to_2010_PUMA.txt";types=String)
acs_hh = read_df("bak/hh_all.csv",types=Dict("Geo"=>String))
od_matrix = read_df("processed/work_od_matrix_no_inc.csv"; types=Dict("h_cbg"=>String))
dConfig = tryJSON("geos.json")
geos = String.(dConfig["geos"])

c10[!,"Tract"] = c10.STATEFP .* c10.COUNTYFP .* c10.TRACTCE
c10[!,"County"] = c10.STATEFP .* c10.COUNTYFP
c10 = c10[[(r.STATEFP in geos || r.County in geos) for r in eachrow(c10)], ["Tract","PUMA5CE"]]

cbgs_in_acs = acs_hh.Geo
tracts_in_acs = unique( [x[1:end-1] for x in acs_hh.Geo] )
tracts_in_c10 = c10.Tract
all(sort(tracts_in_acs) .== sort(tracts_in_c10))

cbg_work_dests = names(od_matrix)[2:end-1]
cbg_origins = od_matrix.h_cbg
all([in(x,cbgs_in_acs) for x in cbg_work_dests])
all([in(x,cbgs_in_acs) for x in cbg_origins])

mask = [!in(x,cbg_origins) for x in cbgs_in_acs]
not_in_origins = cbgs_in_acs[mask]
acs_hh[[r.Geo in not_in_origins for r in eachrow(acs_hh)],:]


## test location-based contact matrices

loc_mat_keys = dser_path("jlse/loc_mat_keys.jlse")
work_loc_contact_mat = dser_path("jlse/work_loc_contact_mat.jlse")
res_loc_contact_mat = dser_path("jlse/res_loc_contact_mat.jlse")
work_loc_lookup = dser_path("jlse/work_loc_lookup.jlse")
res_loc_lookup = dser_path("jlse/res_loc_lookup.jlse")

w = dser_path("jlse/company_workers.jlse") ## employers/employees (with work locations)
hh = dser_path("jlse/hh.jlse") ## households/residents (with hh locations)
cbg_idxs = dser_path("jlse/cbg_idxs.jlse") ## location (cbg) keys used in person/hh keys
cbg_idxs = Dict(k=>String31(v) for (k,v) in cbg_idxs)
gqs = dser_path("jlse/gqs.jlse") ## group-quarters/residents (with gq locations)
## assume only non-inst GQ residents are available for ephemeral local contacts
gq_noninst = filterv(x->x.type==:noninst1864, gqs)
## use the same matrix indices as in the regular contact networks
k = dser_path("jlse/adj_mat_keys.jlse")
p_idxs = Dict(k .=> eachindex(k))

## group potential encounters by census tract (CBG seems too restrictive)
hh_tracts = unique(x[1:end-1] for x in values(cbg_idxs))
work_tracts = unique(x[3][1:end-1] for x in keys(w))
tracts = sort(unique([hh_tracts; work_tracts]))

loc_mat_keys_rev = Dict(v=>k for (k,v) in loc_mat_keys)

i = 100
t = findnz(work_loc_contact_mat[:,i])[1]
all(work_loc_lookup[x] == i for x in t)
loc_mat_keys_rev[i]
filterk(x->x[3][1:end-1]==loc_mat_keys_rev[i], w)
reduce(vcat, values(filterk(x->x[3][1:end-1]==loc_mat_keys_rev[i], w)))
t2 = [p_idxs[k[1:3]] for k in reduce(vcat, values(filterk(x->x[3][1:end-1]==loc_mat_keys_rev[i], w)))]
all(sort(t) .== sort(t2))

i = 123
t = findnz(res_loc_contact_mat[:,i])[1]
all(res_loc_lookup[x] == i for x in t)
loc_mat_keys_rev[i]
filterk(x->cbg_idxs[x[2]][1:end-1]==loc_mat_keys_rev[i], hh)
tk1 = reduce(vcat, [h.people for h in values(filterk(x->cbg_idxs[x[2]][1:end-1]==loc_mat_keys_rev[i], hh))])
filterk(x->cbg_idxs[x[2]][1:end-1]==loc_mat_keys_rev[i], gq_noninst)
tk2 = reduce(vcat, [x.residents for x in values(filterk(x->cbg_idxs[x[2]][1:end-1]==loc_mat_keys_rev[i], gq_noninst))])
t2 = [p_idxs[k[1:3]] for k in [tk1;tk2]]
all(sort(t) .== sort(t2))

#=
Copyright 2023 Alexander Tulchinsky

This file is part of Greasypop.

Greasypop is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Greasypop is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License along with Greasypop. If not, see <https://www.gnu.org/licenses/>.
=#

#using Statistics

include("utils.jl")
include("fileutils.jl")

function read_sch_cap()
    sch_cols = Dict("NCESSCH"=>String15,"TEACHERS"=>Int64,"STUDENTS"=>Int64)
    schools = read_df("processed/schools.csv"; select=collect(keys(sch_cols)), types=sch_cols)
    return Dict(schools.NCESSCH .=> schools.STUDENTS)
end

function find_closest(n::Int)
    ## grades offered by each school
    schools = read_df("processed/schools.csv"; types=Dict("NCESSCH"=>String15))
    ## distance matrix
    distmat = read_df("processed/cbg_sch_distmat.csv"; types=Dict("GEOID"=>String15))
    ## reshape and group by geography
    distmat = groupby(stack(distmat), :GEOID)
    ## for each grade, store a dict of geo=>schools
    closest = Dict{String3,Dict{String15,Vector{String15}}}()
    ## and the distances
    distances = Dict{String3,Dict{String15,Vector{Float64}}}()

    ## assume kindergartens also offer preschool
    ## (we haven't generated private preschools and don't have enough public preschools)
    schools[:,"G_PK_OFFERED"] .= schools[!,"G_PK_OFFERED"] .| schools[!,"G_KG_OFFERED"]

    for (k,gr) in zip(String3.([["p","k"];string.(1:12)]), [["PK","KG"];string.(1:12)])
        mask = schools[!,"G_"*gr*"_OFFERED"]
        sch_by_geo = Dict{String15,Vector{String15}}()
        dist_by_geo = Dict{String15,Vector{Float64}}()
        ## the keys of distmat are geo groups
        for geo in keys(distmat)
            avail = @view distmat[geo][mask,:]
            topidxs = partialsortperm(avail.value, 1:n)
            sch_by_geo[geo[1]] = String15.(avail.variable[topidxs])
            dist_by_geo[geo[1]] = avail.value[topidxs]
        end
        closest[k] = sch_by_geo
        distances[k] = dist_by_geo
    end

    return closest, distances
end

function read_p_in_school(cbgs::Dict{CBGkey, String15})
    people = dser_path("jlse/people.jlse")
    ## excluding college and grad school
    p_in_school = filterv(p->(!ismissing(p.sch_grade) && !in(p.sch_grade, ["c","g"])), people)

    ## sort by cbg,household so we can make kids in the same household go to the same school
    pkeys = collect(keys(p_in_school))
    idxs = sortperm([x[[3,2]] for x in pkeys])
    pkeys = pkeys[idxs]

    ## person key, grade, cbg code
    return [(k, (p_in_school[k]).sch_grade, cbgs[k[3]]) for k in pkeys]
end


## can't just draw school-wise from closest
## how to explain existence of schools that aren't closest (or 2 closest) for anyone
## model school-choosing behavior??
## -- p depends on distance (p ~ 1/dist) and # remaining spots (p ~ spots_left)
## -- only need to consider n closest
## ...?

## send to closest (or 2 closest) first; people who live together more likely to go to same school
## create schools (= string ids), place people into schools
function generate_schools()

    dConfig = tryJSON("config.json")
    n_schools::Int = get(dConfig, "n_closest_schools", 4)
    ## assign students to closest avaiable school (90%) or 2nd closest (10%)
    prob_closest::Float64 = get(dConfig, "p_closest_school", 0.9)

    closest, _ = find_closest(n_schools)
    cbgs = dser_path("jlse/cbg_idxs.jlse")
    p_in_school = read_p_in_school(cbgs)

    sch_capacity = read_sch_cap()
    ## shrink school capacities to prevent underfilling non-closest schools
    sch_capacity = Dict(k=>round(Int,v*0.8) for (k,v) in sch_capacity)

    ## school code => vector of person keys
    sch_students = Dict{String15,Vector{Pkey}}()
    ## initialize with empty vectors
    for k in keys(sch_capacity)
        sch_students[k] = Vector{Pkey}()
    end

    ## read person key, grade level, and cbg code for each person
    for (pk,gr,geo) in p_in_school
        ## look up closest schools for grade level and cbg
        opts = closest[gr][geo]
        ## find the first that hasn't been filled to capacity
        idx_avail = findfirst(k->sch_capacity[k]>length(sch_students[k]), opts)
        ## if all schools full, try again with increased capacity
        idx_avail = isnothing(idx_avail) ? findfirst(k->1.5*sch_capacity[k]>length(sch_students[k]), opts) : idx_avail
        ## if all schools full, try again with increased capacity
        idx_avail = isnothing(idx_avail) ? findfirst(k->2.5*sch_capacity[k]>length(sch_students[k]), opts) : idx_avail
        ## if still full, just overfill the closest
        idx_avail = isnothing(idx_avail) ? 1 : idx_avail
        ## choose closest or next closest
        idx_choice = rand() < prob_closest ? idx_avail : idx_avail+1
        idx_choice = idx_choice > lastindex(opts) ? 1 : idx_choice
        ## append student to school
        push!(sch_students[opts[idx_choice]], pk)
    end

    ## save to file for next step
    ser_path("jlse/sch_students.jlse", sch_students)
    return nothing
end

#=
Copyright 2023 Alexander Tulchinsky

This file is part of Greasypop.

Greasypop is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Greasypop is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License along with Greasypop. If not, see <https://www.gnu.org/licenses/>.
=#

using Distributed
include("fileutils.jl")

## the definitions in this block are sent to all processors
@everywhere begin

    ## for sharing data between local processors without copying
    using SharedArrays

    ## mutation function replaces one element in combs with an element from opts
    ## avoid making an array copy, it only takes 1 assignment to revert
    function mutate!(comb, opts)
        cidx = rand(eachindex(comb))
        orig = comb[cidx]
        comb[cidx] = rand(opts) ## mutate passed vector
        return (cidx,orig) ## return info needed to revert
    end

    function revert!(comb,(cidx,orig))
        comb[cidx] = orig
        return nothing
    end

    ## pick the rows given by idxs from the pop, return summary of columns
    ##  use view() to avoid making a copy
    summarize(idxs::Vector{Int64}, pop::Matrix{Int64}) = sum(view(pop,idxs,:), dims=1)
    ## use sum!() to save on array allocations
    function summarize!(dest::Matrix{Int64}, idxs::Vector{Int64}, pop::Matrix{Int64})
        sum!(dest, view(pop,idxs,:))
        return nothing
    end

    ## distance functions
    ## note if coming from Numpy: Julia functions do not automatically broadcast over collections
    ## --- must specify that intent using dot-syntax: .+ for operators, f.() for functions
    ## (also, Julia docs said to avoid collections of abstract types, hence the polymorphic
    ##   type specification "Matrix{T} where T<:Real" instead of the simpler Matrix{Real})
    ## FTdist is 1/4 * Freeman-Tukey distance
    ## -- multiply by 4 to get something with a chi-sq distribution with len(v)-1 d.f.
    #FTdist(v1::Matrix{T},v2::Matrix{T}) where T<:Real = sum((sqrt.(v1) .- sqrt.(v2)) .^ 2)
    ## zeros are common in target cells, and get penalized too harshly -- add 1 to relax this
    FTdist(v1::Matrix{T},v2::Matrix{T}) where T<:Real = sum((sqrt.(v1 .+ one(T)) .- sqrt.(v2 .+ one(T))) .^ 2)
    ## weighted
    #FTdist(v1::Matrix{T},v2::Matrix{T},wts::Matrix{Float64}) where T<:Real = sum(wts .* ((sqrt.(v1 .+ one(T)) .- sqrt.(v2 .+ one(T))) .^ 2))
    ## or, good ol' euclidean-squared
    #sqdist(v1::Matrix{T},v2::Matrix{T}) where T<:Real = sum((v1 .- v2) .^ 2)

    ## standard simulated annealing acceptance function
    function accept(neg_dE::Float64, T::Float64)
        if neg_dE >= 0
            return true
        else
            p = exp(neg_dE / T)
            return rand() < p
        end
    end

    ## function for stepping down the temperature; adaptive would probably be better?
    function sched(gen, temp, E0, E1, c)
        return temp * c
    end

    ## termination criteria
    function term(gen, E0, temp, max_gens, crit_val, report=1000)
        t = E0 < crit_val || gen > max_gens
        if gen % report == 0 || t
            println(E0, " ", gen, " ", temp)
        end
        return t
    end

    ## optimize with simulated annealing
    ##  returns a vector of indices from samples
    function anneal(glob_samp_ref::SharedMatrix{Int64}, mask::BitVector, targ::Matrix{Int64}, n::Int64, params::Dict{Symbol, R}) where R<:Real
        ## make a local copy of needed samples (this isn't done that often, and should be the fastest approach)
        samples = glob_samp_ref[mask, :]
        ## indices to sample
        ##  note, these index the local subset, not the shared samples
        idxs = axes(samples,1) 
        ## if no valid samples, return a bad score (this shouldn't happen)
        if isempty(idxs)
            return (Vector{Int64}(), 0, Inf, 0.0)
        end
        ## initialize with a random combination of samples
        c0 = rand(idxs,n)
        summary = summarize(c0, samples)
        E0 = FTdist(summary, targ)
        T = 0.5 * E0 ## set initial temperature based on starting distance, I guess?
        gen = 0

        done = false
        while !done
            gen += 1
            orig = mutate!(c0, idxs)
            summarize!(summary, c0, samples)
            E1 = FTdist(summary, targ)
            if accept(E0-E1, T)
                T = sched(gen, T, E0, E1, params[:cooldown])
                E0 = E1 ## only update the score if we accept, lol
            else
                revert!(c0, orig)
            end
            done = term(gen, E0, T, params[:maxgens], params[:critval], params[:report])
        end

        ## convert the answer back to global indices
        ## I wasn't really going to forget to do this, was I?
        res = findall(mask)[c0]

        ## force garbage collection, distributed GC isn't always smart
        GC.gc()

        return (res, gen, E0, T)
    end

    ## closes over params and a reference to shared matrix of samples
    ## returns a fn that uses anneal with given params, and can see the shared samples
    function annealer(shared_samples::SharedMatrix{Int64}, params::Dict{Symbol, R}) where R<:Real
        ## call this function to do the work:
        ##  mask = which samples from shared_samples to use for a given target
        function f(mask::BitVector, targ::Matrix{Int64}, n::Int64)
            return anneal(shared_samples, mask, targ, n, params)
        end
        return f
    end

## end @everywhere
end

## targets are census block group (cbg) summary statistics
function read_targets(targ_idxs=[])
    acs_targets = read_df("processed/acs_targets.csv"; types=Dict("Geo"=>String15))
    if isempty(targ_idxs)
        targ_idxs = axes(acs_targets,1)
    end
    ## pull target stats from the dataframe and convert to matrix or array for faster math 
    targs = [Matrix{Int64}(acs_targets[[targ_id],2:end]) for targ_id in targ_idxs]
    geos = [acs_targets[targ_id,1] for targ_id in targ_idxs]
    return (targs, geos, names(acs_targets)[2:end])
end

## number of households in each cbg
function read_hh_counts()
    hhcdf = read_df("processed/hh_counts.csv"; types=Dict("Geo"=>String15))
    ## convert to dicts for easier lookup
    ##  note the .=> syntax; this broadcasts associations between two arrays, similar to dict(zip()) in python
    return Dict(hhcdf[:,1] .=> hhcdf[:,2])
end

## returns a sharedmatrix of samples -- can pass it to local parallel processes without copying data
function read_samples()
    puma_samples_all = read_df("processed/census_samples.csv"; types=Dict("SERIALNO"=>String15))
    hh_ids = puma_samples_all[:,1] ## for looking up the household serial numbers later
    shared_samples = convert(SharedMatrix, Matrix{Int64}(puma_samples_all[:,2:end]))
    return (shared_samples, hh_ids)	
end

## geographic data for target cbg's -- will use these to determine which samples to use
function read_targ_geo()
    cbg_geo_cols = Dict("Geo"=>String15,"st_puma"=>String7,"cbsa"=>String7,"county"=>String7,"R"=>Float64,"U"=>Float64)
    cbg_geo = read_df("processed/cbg_geo.csv"; select=collect(keys(cbg_geo_cols)), types=cbg_geo_cols)
    cbg_puma = Dict(cbg_geo[:,"Geo"] .=> cbg_geo[:,"st_puma"])
    cbg_county = Dict(cbg_geo[:,"Geo"] .=> cbg_geo[:,"county"])
    cbg_cbsa = Dict(cbg_geo[:,"Geo"] .=> cbg_geo[:,"cbsa"])
    cbg_urban = Dict(cbg_geo[:,"Geo"] .=> cbg_geo[:,"U"])
    return (cbg_puma, cbg_county, cbg_cbsa, cbg_urban)
end

## for finding samples with similar urbanization to target urbanization x
function urbanization_lookup(df::DataFrame, x::Float64)
    if x > 0.999
        ## if df has a missing cell, comparison will return "missing"
        ## -- coalesce() makes it return "false" instead
        return (coalesce.(df.U .> 0.999, false))
    elseif x < 0.334
        return (coalesce.(df.U .< 0.334, false))
    else
        a = x - 0.1; b = min(x+0.1, 0.999)
        return (coalesce.(a .< df.U .< b, false))
    end
end

## looks up which samples in df to use, based on column name k and associated geo data of targets
## don't usually need to specify function return types but in this case, target_geo_codes might be empty and 
##   this way it still returns a vector{BitVector}
function sample_lookup(df::DataFrame, k::Symbol, target_geo_codes)::Vector{BitVector}
    if k == :U
        return [urbanization_lookup(df,x) for x in target_geo_codes]
    else
        ## note .== syntax for element-wise comparison
        return [coalesce.(df[!,k] .== x, false) for x in target_geo_codes]
    end
end

## creates annealing function and executes it on available processors
## returns a vector of whatever anneal() returns
function optimize(samples::SharedMatrix{Int64}, samp_masks::Vector{BitVector}, targs::Vector{Matrix{Int64}}, n_hhs::Vector{Int64}, params)
    a_fn = annealer(samples, params)
    ## use pmap for this, not @distributed for
    return pmap(a_fn, samp_masks, targs, n_hhs)
end

## like optimize, but overwrites previous results in vector "x" at the indices given by "rerun"
function reoptimize!(x, rerun::Vector{Int64}, samples::SharedMatrix{Int64}, 
    samp_masks::Vector{BitVector}, targs::Vector{Matrix{Int64}}, n_hhs::Vector{Int64}, params_r)

    ## make sure we found enough suitable samples for each target
    enough_samps = sum.(samp_masks) .> (n_hhs[rerun] .// 2)
    rerun = rerun[enough_samps]
    ## make sure there's actually something to rerun
    if lastindex(rerun) > 0
        a_fn = annealer(samples, params_r)
        x_r = pmap(a_fn, samp_masks, targs[rerun], n_hhs[rerun])
        ## only overwrite the ones whose score improved
        improved = [a[3] for a in x_r] .< [a[3] for a in x[rerun]]
        ## note .= syntax for broadcasting assignment to an array
        x[rerun[improved]] .= x_r[improved]
    end
    return nothing
end

## performs several optimization runs on the target cbg's in each county
## writes each county's results to a separate file
function process_counties(counties=[])

    samples, hh_ids = read_samples()
    cbg_puma, cbg_county, cbg_cbsa, cbg_urban = read_targ_geo()
    samp_geo_cols = Dict("SERIALNO"=>String15,"st_puma"=>String7,"cbsa"=>String7,"county"=>String7,"R"=>Float64,"U"=>Float64)
    samp_geo = read_df("processed/samp_geo.csv"; select=collect(keys(samp_geo_cols)), types=samp_geo_cols)
    ## samp geo indices match those in census_samples
    ## all(samp_geo.SERIALNO .== hh_ids)
    targs_all, geos_all, targ_colnames = read_targets()
    hh_counts = read_hh_counts()
    ## number of households in each target
    n_hhs_all = [hh_counts[g] for g in geos_all]
    ## each target's county
    county = [g[1:5] for g in geos_all]

    ## weight households more than individuals? (not currently implemented)
    #targ_weights = [ones(1,43).*2.0 ones(1,length(targ_colnames)-43)]
    dConfig = tryJSON("config.json")
    c_val::Float64 = get(dConfig, "CO_crit_val", 10.0)
    CO_cooldown::Float64 = get(dConfig, "CO_cooldown", 0.99)
    CO_cooldown_slow = 0.5 + 0.5 * CO_cooldown
    CO_maxgens::Int = get(dConfig, "CO_maxgens", 200000)
    CO_report = CO_maxgens + 1
    
    params = Dict(:maxgens => CO_maxgens, :critval => c_val, :cooldown => CO_cooldown, :report => CO_report)

    ## run all counties by default
    if isempty(counties)
        counties = unique(county)
    end

    mkpath("jlse/CO")
    for c in counties
        targs = targs_all[county .== c]
        geos = geos_all[county .== c]
        n_hhs = n_hhs_all[county .== c]

        println("\n puma \n")
        ## look up samples for each target based on target's puma code
        ## puma is the most local sample level, has the fewest samples available
        samp_masks = sample_lookup(samp_geo, :st_puma, [cbg_puma[g] for g in geos])
        x = optimize(samples, samp_masks, targs, n_hhs, params)

        println("\n county \n")
        ## rerun poor matches using county-level
        rerun = findall([a[3]>c_val for a in x])
        samp_masks = sample_lookup(samp_geo, :county, [cbg_county[g] for g in geos[rerun]])
        params_r = Dict(:maxgens => CO_maxgens, :critval => c_val, :cooldown => CO_cooldown, :report => CO_report)
        reoptimize!(x, rerun, samples, samp_masks, targs, n_hhs, params_r)

        println("\n cbsa \n")
        ## cbsa-level
        rerun = findall([a[3]>c_val for a in x])
        samp_masks = sample_lookup(samp_geo, :cbsa, [cbg_cbsa[g] for g in geos[rerun]])
        params_r = Dict(:maxgens => CO_maxgens, :critval => c_val, :cooldown => CO_cooldown, :report => CO_report)
        reoptimize!(x, rerun, samples, samp_masks, targs, n_hhs, params_r)
        
        println("\n urb \n")
        ## urbanization level, has the most samples; more likely to match but longer to search
        ##  (also the least associated with the target's local geography)
        rerun = findall([a[3]>c_val for a in x])
        samp_masks = sample_lookup(samp_geo, :U, [cbg_urban[g] for g in geos[rerun]])
        params_r = Dict(:maxgens => CO_maxgens, :critval => c_val, :cooldown => CO_cooldown_slow, :report => CO_report)
        reoptimize!(x, rerun, samples, samp_masks, targs, n_hhs, params_r)

        ## store results as dict keyed by cbg code; look up actual hh id's of sample indices
        scores = Dict(geos .=> [a[3] for a in x])
        households = Dict(geos .=> [hh_ids[a[1]] for a in x])

        serialize(abspath("jlse/CO/hh"*c*".jlse"),households)
        serialize(abspath("jlse/CO/hh"*c*"_scores.jlse"),scores)

        ## force garbage collection, distributed GC isn't always smart
        GC.gc()
    end

    return nothing
end


process_counties()

#=
Copyright 2023 Alexander Tulchinsky

This file is part of Greasypop.

Greasypop is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Greasypop is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License along with Greasypop. If not, see <https://www.gnu.org/licenses/>.
=#

include("households.jl")
include("schools.jl")
include("workplaces.jl")
include("netw.jl")

println("creating people, households, and group quarters")
generate_people()
println("creating schools")
generate_schools()
println("creating workplaces")
generate_commute_matrices()
generate_jobs_and_workers()
println("creating network")
generate_networks()
generate_location_matrices()
println("done")

#=
Copyright 2023 Alexander Tulchinsky

This file is part of Greasypop.

Greasypop is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Greasypop is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License along with Greasypop. If not, see <https://www.gnu.org/licenses/>.
=#

include("utils.jl")
include("fileutils.jl")

mkpath("pop_export")

println("households and people")

d = dser_path("jlse/cbg_idxs.jlse")
df = DataFrame(sort([
            (cbg_id=Int64(k), cbg_geocode=String(v))
            for (k,v) in d
            ], by=x->x.cbg_id))
write_df("pop_export/cbg_idxs.csv",df)

d = dser_path("jlse/hh.jlse")
df = DataFrame(sort([
            (hh_id=Int(k[1]), cbg_id=Int(k[2]), sample_index=Int(v.sample), n_people=length(v.people))
            for (k,v) in d
            ], by=x->(x.cbg_id,x.hh_id)))
write_df("pop_export/hh.csv",df)

d = dser_path("jlse/people.jlse")
df = DataFrame(sort([
            (p_id=Int(k[1]), hh_id=Int(k[2]), cbg_id=Int(k[3]), sample_index=mcon(Int,v.sample),
            age=mcon(Int,v.age), female=mcon(Int,v.female), working=mcon(Int,v.working), commuter=mcon(Int,v.commuter), 
            commuter_income_category=mcon(Int,v.com_inc) , commuter_workplace_category=mcon(Int,v.com_cat),
			race_black_alone=mcon(Int,v.race_black_alone), white_non_hispanic=mcon(Int,v.white_non_hispanic), hispanic=mcon(Int,v.hispanic),
            sch_grade=mcon(String,v.sch_grade))
            for (k,v) in d
            ], by=x->(x.cbg_id,x.hh_id,x.p_id)))
write_df("pop_export/people.csv",df)

d = nothing
GC.gc()

println("schools")

d = dser_path("jlse/sch_students.jlse")
df = DataFrame(sort([
            (sch_code=String(k), p_id=Int(v[1]), hh_id=Int(v[2]), cbg_id=Int(v[3]))
            for (k,v) in dflat(d)
            ], by=x->x.sch_code))
write_df("pop_export/sch_students.csv",df)

d = dser_path("jlse/sch_workers.jlse")
df = DataFrame(sort([
            (sch_code=String(k), p_id=Int(v[1]), hh_id=Int(v[2]), cbg_id=Int(v[3]))
            for (k,v) in dflat(d)
            ], by=x->x.sch_code))
write_df("pop_export/sch_workers.csv",df)

println("group quarters")

d = dser_path("jlse/gqs.jlse")
df = DataFrame(sort([
            (gq_id=Int(k[1]), cbg_id=Int(k[2]), gq_type=String(v.type), n_residents=length(v.residents))
            for (k,v) in d
            ], by=x->(x.cbg_id,x.gq_id)))
write_df("pop_export/gqs.csv",df)

d = Dict(k=>v.residents for (k,v) in d)
df = DataFrame(sort([
            (gq_id=Int(k[1]), cbg_id=Int(k[2]), p_id=Int(v[1]), hh_id=Int(v[2]))
            for (k,v) in dflat(d)
            ], by=x->(x.cbg_id,x.gq_id)))
write_df("pop_export/gq_residents.csv",df)

println("workplaces")

d = dser_path("jlse/gq_workers.jlse")
df = DataFrame(sort([
            (gq_id=Int(k[1]), gq_cbg_id=Int(k[2]), p_id=Int(v[1]), p_hh_id=Int(v[2]), p_cbg_id=Int(v[3]))
            for (k,v) in dflat(d)
            ], by=x->(x.gq_cbg_id,x.gq_id)))
write_df("pop_export/gq_workers.csv",df)

d = dser_path("jlse/company_workers.jlse")
df = DataFrame(sort([
            (employer_geo_code=String(k[3]), employer_type=Int(k[2]), employer_num=Int(k[1]), p_id=Int(v[1]), p_hh_id=Int(v[2]), p_cbg_id=Int(v[3]))
            for (k,v) in dflat(d)
            ], by=x->(x.employer_geo_code,x.employer_type,x.employer_num)))
write_df("pop_export/company_workers.csv",df)

d = dser_path("jlse/outside_workers.jlse")
df = DataFrame(sort([
            (p_id=Int(v[1]), p_hh_id=Int(v[2]), p_cbg_id=Int(v[3]))
            for (k,v) in dflat(d)
            ], by=x->(x.p_cbg_id,x.p_hh_id,x.p_id)))
write_df("pop_export/outside_workers.csv",df)

d = nothing
GC.gc()

println("done")

#=
Copyright 2023 Alexander Tulchinsky

This file is part of Greasypop.

Greasypop is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Greasypop is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License along with Greasypop. If not, see <https://www.gnu.org/licenses/>.
=#

using Graphs
#using GraphPlot
using SparseArrays
using LinearAlgebra
using Random
using Distributions

include("utils.jl")
include("fileutils.jl")

## neighbors for each vertex in graph g
function neighVec(g)
    return [neighbors(g,x) for x in vertices(g)]
end

function read_gq_ppl()
    ## gq residents
    gq_res = Dict(k => v.residents for (k,v) in dser_path("jlse/gqs.jlse"))
    ## gq employees; remove extra worker tag
    gq_workers = Dict(k => [x[1:3] for x in v] for (k,v) in dser_path("jlse/gq_workers.jlse"))
    return vecmerge(gq_res, gq_workers)
end

function assign_teachers_to_grades(school_key::String15,students_by_grade::Vector{S},sch_workers::Dict{String15,Vector{Pkey}}) where S<:Any
    ## person ids of teachers in this school
    teachers = sch_workers[school_key]
    ## a school could have been created with teachers but no students
    if isempty(students_by_grade) 
        return [(t...,String3("0")) for t in teachers]
    else
        ## proportionmap from statsbase: p students in each grade in this school
        pstudents = proportionmap([x[4]::String3 for x in students_by_grade])
        ## n teachers by grade, assuming it's exactly proportional to students
        n_tmp = Dict(k=>v*length(teachers) for (k::String3,v::Float64) in pstudents)
        ## round to integers and expand into a vector having the same length as "teachers"
        teacher_grades = reduce(vcat, fill(k,v) for (k::String3,v::Int) in Dict(keys(n_tmp) .=> lrRound(collect(values(n_tmp)))))
        ## append grade to each teacher's person id (teacher order is already random)
        return [(t...,g) for (t::Pkey,g::String3) in zip(teachers,teacher_grades)]
    end
end

function read_sch_ppl()
    ## for looking up the school grade of each student:
    ppl = Dict(k=>v.sch_grade for (k,v) in dser_path("jlse/people.jlse"))
    ## append each student's grade to their person id
    sch_students_x_grade = Dict{String15,Vector{Tuple{fieldtypes(Pkey)...,String3}}}(k=>[(personkey..., ppl[personkey]) 
        for personkey in v] for (k,v) in dser_path("jlse/sch_students.jlse"))
    ## strip income category from school workers, leaving only person id
    sch_workers = Dict(k => [x[1:3] for x in v] for (k,v) in dser_path("jlse/sch_workers.jlse"))
    ## assign a grade to each teacher and append it to their person id
    teachers_by_grade = Dict(k => assign_teachers_to_grades(k,v,sch_workers) for (k,v) in sch_students_x_grade)
    ## return students and teachers by school
    return vecmerge(sch_students_x_grade,teachers_by_grade)
end

function read_hh_ppl()
    hh = dser_path("jlse/hh.jlse")
    return Dict(k => v.people for (k,v) in hh)
end

## "dummies" = people commuting from outside the synth area, have no household or location info
function get_dummies()
    ## remove extra worker tag
    return [x[1:3] for x in dser_path("jlse/work_dummies.jlse")]
end

## integer index for each "real" person in synth pop, and for each "dummy" person
function person_indices()
    ## everyone in households and gq's in the synth area
    people = keys(dser_path("jlse/people.jlse"))
    ## workers without households
    dummies = get_dummies()    

    n = length(people)
    return (
        Dict(people .=> 1:n),
        Dict(dummies .=> (1+n):(n+length(dummies)))
        )
end

## connects the keys in keyvec into a stochastic block model (SBM) network
## - note, the degree distribution within blocks in an SBM is similar to 
##      a random (erdos-renyi) network. For a more realistic degree distribution (e.g., with hubs)
##      try a degree-corrected SBM (Karrer & Newman 2010, https://arxiv.org/abs/1008.3926)
##
## if use_groups is true, the 4th element of a key should be the group identity (the first 3 would be a person key)
## returns a list of (source, dest) edges where source and dest are keys in keyvec
function connect_SBM(keyvec::Vector{T}, K::Int, min_N::Int, assoc_coeff::Float64, use_groups::Bool=true) where T<:Any
    keyvec = unique(keyvec) ## duplicates would result in self-connections
    n = length(keyvec)
    if n < 2 ## nothing to connect
        return Tuple{T,T}[]
    elseif n < min_N ## more than one but less than thresh = fully connected
        g = complete_graph(n)
        ## indices in g correspond to positions in keyvec
        return [(keyvec[x.src],keyvec[x.dst]) for x in edges(g)]
    else
        ## more than min_N = use SBM
        if use_groups
            ## group membership is based on key element #4
            group_labels = unique(k[4] for k in keyvec)
            group_indices = [findall(k->k[4]==g, keyvec) for g in group_labels] 
        else 
            ## otherwise put everyone in one group
            group_indices = [eachindex(keyvec)] 
        end

        len_grp_idx = length.(group_indices) ## number of vertices in each group
        n_vec = filter(x->x>0, len_grp_idx) ## drop any 0-size groups
        n_groups = length(n_vec)
        w_planted = Diagonal(fill(K,n_groups)) ## contact matrix if no group mixing
        prop_i = n_vec ./ sum(n_vec) ## proportion in each group
        w_random = repeat(transpose(prop_i) * K, n_groups) ## contact matrix if random group mixing
        c_matrix = assoc_coeff * w_planted + (1 - assoc_coeff) * w_random  ## linear interpolation between planted and random contact matrices

        ## can't have more than n connections to a group
        for r in eachrow(c_matrix)
            r .= min.(r,n_vec)
        end
        ## can't have more than n-1 within-group connections
        d_tmp = view(c_matrix, diagind(c_matrix))
        d_tmp .= min.(d_tmp, n_vec .- 1)

        ## note, graph gen function takes group sizes in n_vec; the vertices/edges in the
        ##  resulting graph are just numbered based on group sizes, in the order given in n_vec
        ##  to recover keys, need to translate g index -> keyvec index -> key
        g = stochastic_block_model(c_matrix,n_vec)
        keyvec_indices = reduce(vcat, group_indices) ## for translating indices

        ## algo sometimes creates 0-degree vertices; not technically wrong, but force them to have 1 connection anyway
        fix_zeros = findall(degree(g).==0)
        for x in fix_zeros
            add_edge!(g, x, rand(vertices(g)))
        end

        ## convert indices in g to keyvec keys for each edge
        result = Tuple{T,T}[]
        for x in edges(g)
            if use_groups
                (group_labels[findfirst(c->in(x.src,c) , ranges(len_grp_idx))] == keyvec[keyvec_indices[x.src]][4]) &&
                    (group_labels[findfirst(c->in(x.dst,c) , ranges(len_grp_idx))] == keyvec[keyvec_indices[x.dst]][4]) ||
                    throw("group assignment error")
            end
            
            push!(result, (keyvec[keyvec_indices[x.src]],keyvec[keyvec_indices[x.dst]]))
        end
        return result
    end ## if n
end

## as above, but using a simple small-world network
function connect_small_world(keyvec::Vector{T}, K::Int, min_N::Int, B::Float64) where T<:Any
    keyvec = unique(keyvec) ## e.g., duplicates happen if someone lives and works at the same gq
    n = length(keyvec) ## size of group
    if n < 2 ## nothing to connect
        return Tuple{T,T}[]
    elseif n < min_N ## more than one but less than thresh = fully connected
        g = complete_graph(n)
    else
        g = watts_strogatz(n, K, B) ## small-world network
    end
    ## indices in g correspond to positions in keyvec
    return [(keyvec[x.src],keyvec[x.dst]) for x in edges(g)]
end

## as above, but completely connected graph
function connect_complete(keyvec::Vector{T}) where T<:Any
    keyvec = unique(keyvec)
    n = length(keyvec) ## size of group
    if n < 2 ## nothing to connect
        return Tuple{T,T}[]
    else
        g = complete_graph(n)
    end
    ## indices in g correspond to positions in keyvec
    return [(keyvec[x.src],keyvec[x.dst]) for x in edges(g)]
end

## sparse adjacency matrix of bits should be an efficient way to store the network
## (also, simple to convert to Graphs.jl graph for analysis)
## (also, has good lookup performance, same as hash table)
function sp_from_groups(connect_fn, keygroups::Vector{Vector{T}}, p_idxs::Dict{Pkey,Int64}) where T<:Tuple
    src_idxs = Int64[]
    dst_idxs = Int64[]

    for keyvec in keygroups 
        ## connect keys into network, then convert to integer indices
        for (s_key, d_key) in connect_fn(keyvec)
            ## key elements 1-3 correspond to a person key
            push!(src_idxs, p_idxs[s_key[1:3]])
            push!(dst_idxs, p_idxs[d_key[1:3]])
        end
    end

    ## create sparse matrix from indices
    return sparse([src_idxs;dst_idxs],[dst_idxs;src_idxs],
                        trues(length(src_idxs)+length(dst_idxs)),
                        length(p_idxs),length(p_idxs)) ## ensure size is p_idxs by p_idxs
end


##
## generate all networks
##
function generate_networks()

    dConfig = tryJSON("config.json")
    work_K::Int = get(dConfig, "workplace_K", 8) ## mean degree for wp networks
    school_K::Int = get(dConfig, "school_K", 12) ## mean degree for school networks
    gq_K::Int = get(dConfig, "gq_K", 12) ## mean degree for group-quarters networks
    other_K::Int = get(dConfig, "netw_K", 8) ## mean degree for other networks
    sm_world_B::Float64 = get(dConfig, "netw_B", 0.25) ## beta param for small world networks
    work_assoc_coeff::Float64 = get(dConfig, "income_associativity_coefficient", 0.9) ## group associativity for workplace networks
    sch_assoc_coeff::Float64 = get(dConfig, "school_associativity_coefficient", 0.9) ## group associativity for school networks
    
    ## from workplaces.jl; workers grouped into companies
    ## worker is (person id, hh id, cbg id, income category)
    company_workers = collect(values(dser_path("jlse/company_workers.jlse")))
    #school students and teachers
    ## student/teacher is (person id, hh id, cbg id, grade) -- first 3 are a person key
    ppl_in_schools = collect(values(read_sch_ppl()))
    ## gq residents and employees 
    ppl_in_gq = collect(values(read_gq_ppl()))
    
    ## households; assume they're fully connected (and maybe have a higher transmission rate within)
    hh_ppl = read_hh_ppl()
    ## save household membership Dict
    ser_path("jlse/hh_ppl.jlse", hh_ppl)
    ## just groups as vectors
    ppl_in_hhs = collect(values(hh_ppl))
    
    ## each person needs an integer index
    p_idxs, dummy_idxs = person_indices()
    ## save dummies to file; these ppl have workplace but no household; sim should infect them randomly at home
    ser_path("jlse/adj_dummy_keys.jlse", Dict(v=>k for (k,v) in dummy_idxs))
    ## merge people and dummies for network
    merge!(p_idxs, dummy_idxs)
    ## will need the index keys to look up people
    ser_path("jlse/adj_mat_keys.jlse", first.(sort(collect(p_idxs),by=p->p[2])))
    
    ## generate network
    ## workplaces: using stochastic block model (SBM) network
    ## so that all results are comparable, use the SBM algo even if there's only one income group in a wp
    adj_wp = sp_from_groups(v->connect_SBM(v, work_K, work_K+2, work_assoc_coeff, true), company_workers, p_idxs)
    ## schools: using SBM, grouped by grade
    adj_sch = sp_from_groups(v->connect_SBM(v, school_K, school_K+2, sch_assoc_coeff, true), ppl_in_schools, p_idxs)
    ## other institutions (currently just gq's) : using small-world network
    adj_gq = sp_from_groups(v->connect_small_world(v, gq_K, gq_K+2, sm_world_B), ppl_in_gq, p_idxs)
    ## households are fully connected
    adj_hh = sp_from_groups(v->connect_complete(v), ppl_in_hhs, p_idxs)
    ## save combined non-hh netw for when those distinctions are not needed
    adj_mat_non_hh = adj_wp .| adj_sch .| adj_gq
    
    ## matrices must be symmetrical, save space by only storing half
    ser_path("jlse/adj_mat_non_hh.jlse",sparse(UpperTriangular(adj_mat_non_hh)))
    ser_path("jlse/adj_mat_wp.jlse",sparse(UpperTriangular(adj_wp)))
    ser_path("jlse/adj_mat_sch.jlse",sparse(UpperTriangular(adj_sch)))
    ser_path("jlse/adj_mat_gq.jlse",sparse(UpperTriangular(adj_gq)))
    ser_path("jlse/adj_mat_hh.jlse",sparse(UpperTriangular(adj_hh)))
    
    ## keep track of people working outside synth area (have no workplace network, sim should infect them randomly at work)
    outside_workers = dser_path("jlse/outside_workers.jlse")
    ser_path("jlse/adj_out_workers.jlse", Dict(p_idxs[only(x)[1:3]] => only(x)[1:3] for x in values(outside_workers)))
    
    return nothing   
end


##
## generate info needed to simulate ephemeral location-based contacts
##

## assume that the chance of meeting a neighbor is the same as meeting someone who works in your neighborhood
##  (otherwise need another parameter to describe the difference)

## group potential encounters by census tract (CBG seems too restrictive)

## home locations; e.g, 
## cbg A: people 1, 2
## cbg B: 3, 4
##
## work locations; e.g., 
## cbg A: 1, 3
## cbg B: 2
##
## at home, person 1 could meet: 2, 3
##          person 2 could meet: 1, 3
##          person 3 could meet: 4, 2
##
## at work, person 1 could meet: 3, 2
##          person 2 could meet: 3, 4
##          person 3 could meet: 1, 2

## make a separate matrix for home and work neighborhood contacts?
##  (# of contact events could be independent, or maybe work is closed)
## matrix is not symmetrical (local resident you meet while at work probably won't meet you when they're at work)
## "source" person will be column (because reading by columns is faster in julia)

## home neighborhood contacts
##  for each location:
##   for each person who lives there (hh or non-inst gq):
##    look up everyone else who lives there (hh or gq) + append everyone who works there
## work neighborhood contacts
##  for each location:
##   for each person who works there:
##    look up everyone else who works there + append everyone who lives there (hh or non-inst gq)

## save memory by not generating the contact matrix
##  just a matrix of locations (columns) x people (rows)
##  then simple O1 look-up to get a person's home or work location, and pick from that column

function generate_location_matrices()

    w = dser_path("jlse/company_workers.jlse") ## employers/employees (with work locations)
    hh = dser_path("jlse/hh.jlse") ## households/residents (with hh locations)
    cbg_idxs = dser_path("jlse/cbg_idxs.jlse") ## location (cbg) keys used in person/hh keys
    cbg_idxs = Dict(k=>String31(v) for (k,v) in cbg_idxs)
    gqs = dser_path("jlse/gqs.jlse") ## group-quarters/residents (with gq locations)
    ## assume only non-inst GQ residents are available for ephemeral local contacts
    ni_types = Set([:milGQ, :ninst1864civ])
    gq_noninst = filterv(x->(x.type in ni_types), gqs)
    ## use the same matrix indices as in the regular contact networks
    k = dser_path("jlse/adj_mat_keys.jlse")
    p_idxs = Dict(k .=> eachindex(k))

    ## group potential encounters by census tract (CBG seems too restrictive)
    hh_tracts = unique(x[1:end-1] for x in values(cbg_idxs))
    work_tracts = unique(x[3][1:end-1] for x in keys(w))
    tracts = sort(unique([hh_tracts; work_tracts]))

    ## convert tract codes to integer indices for constructing a matrix
    loc_idxs = Dict(tracts .=> eachindex(tracts))
    ## save location indices
    ser_path("jlse/loc_mat_keys.jlse",loc_idxs)

    ## group individuals by tract code (= cbg code minus last character)
    ## dataframe provides fast grouping
    w_df_by_loc = groupby(DataFrame((k[3][1:end-1], v) for (k,v) in w), "1")
    ## place person-vectors in a dict with integer tract indices as the keys
    workers_by_loc = Dict(loc_idxs[loc["1"]]=>reduce(vcat, w_df_by_loc[loc][!,"2"]) for loc in keys(w_df_by_loc))
    ## convert person keys to network matrix indices (same indices as regular contact networks)
    w_idxs_by_loc = Dict(k=>[p_idxs[i[1:3]] for i in v] for (k,v) in workers_by_loc)

    h_df_by_loc = groupby(DataFrame((cbg_idxs[k[2]][1:end-1], v.people) for (k,v) in hh), "1")
    hh_ppl_by_loc = Dict(loc_idxs[loc["1"]]=>reduce(vcat, h_df_by_loc[loc][!,"2"]) for loc in keys(h_df_by_loc))
    hh_idxs_by_loc = Dict(k=>[p_idxs[i] for i in v] for (k,v) in hh_ppl_by_loc)

    gq_df_by_loc = groupby(DataFrame((cbg_idxs[k[2]][1:end-1], v.residents) for (k,v) in gq_noninst), "1")
    gq_ppl_by_loc = Dict(loc_idxs[loc["1"]]=>reduce(vcat, gq_df_by_loc[loc][!,"2"]) for loc in keys(gq_df_by_loc))
    gq_idxs_by_loc = Dict(k=>[p_idxs[i] for i in v] for (k,v) in gq_ppl_by_loc)

    ## residential locations include households and non-inst GQs:
    res_idxs_by_loc = vecmerge(hh_idxs_by_loc, gq_idxs_by_loc)

    ## construct matrices for use in simulation
    ## columns are locations, rows are people (because we'll be looking up by location)
    ##  note, currently people have one job max
    w_loc_contact_mat = sparse(
        reduce(vcat, collect(values(w_idxs_by_loc))), 
        reduce(vcat, [fill(k,length(v)) for (k,v) in w_idxs_by_loc]),
        trues(sum(length.(values(w_idxs_by_loc)))),
        length(k),length(tracts)
    )

    res_loc_contact_mat = sparse(
        reduce(vcat, collect(values(res_idxs_by_loc))), 
        reduce(vcat, [fill(k,length(v)) for (k,v) in res_idxs_by_loc]),
        trues(sum(length.(values(res_idxs_by_loc)))),
        length(k),length(tracts)
    )

    ser_path("jlse/work_loc_contact_mat.jlse",w_loc_contact_mat)
    ser_path("jlse/res_loc_contact_mat.jlse",res_loc_contact_mat)

    ## save work and home loc idx for each person idx, for fast lookup
    ##  note, currently people have one job max
    w_loc_by_p_idx = Dict(reduce(vcat, [v .=> k for (k,v) in w_idxs_by_loc]))
    res_loc_by_p_idx = Dict(reduce(vcat, [v .=> k for (k,v) in res_idxs_by_loc]))

    ser_path("jlse/work_loc_lookup.jlse",w_loc_by_p_idx)
    ser_path("jlse/res_loc_lookup.jlse",res_loc_by_p_idx)

    return nothing
end

#=
Copyright 2023 Alexander Tulchinsky

This file is part of Greasypop.

Greasypop is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Greasypop is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License along with Greasypop. If not, see <https://www.gnu.org/licenses/>.
=#

#using Statistics

include("utils.jl")
include("fileutils.jl")

function read_counties()
    cbg_geo_cols = Dict("Geo"=>String15,"st_puma"=>String7,"cbsa"=>String7,"county"=>String7,"R"=>Float64,"U"=>Float64)
    cbg_geo = read_df("processed/cbg_geo.csv"; select=collect(keys(cbg_geo_cols)), types=cbg_geo_cols)
    return unique(cbg_geo.county)
end

## for looking up row # by hh serial
function read_hh_serials()
    hh_samps = read_df("processed/hh_samples.csv"; types=Dict("SERIALNO"=>String15))
    return Dict(hh_samps.SERIALNO .=> eachindex(hh_samps.SERIALNO))
end

## read person samples into a dataframe
function read_psamp_df(ind_codes::Vector{<:AbstractString}, additional_traits::Vector{<:AbstractString})
    nonbool_cols = ["SERIALNO","AGEP","sch_grade"]
    bool_cols = ["commuter","has_job","com_LODES_low","com_LODES_high"]
    ind_cols = ["ind_"*k for k in ind_codes]
    typedict = Dict(["SERIALNO"=>String15;
                    [x=>Bool for x in bool_cols];
                    ## additional traits are all bools for now
                    [x=>Bool for x in additional_traits];
                    [x=>Bool for x in ind_cols]
                    ])
    df = read_df("processed/p_samples.csv"; select=[nonbool_cols; bool_cols; additional_traits; ind_cols], types=typedict)
    return df[:, [nonbool_cols; bool_cols; additional_traits; ind_cols]]
end

## for looking up all person samps by hh serial
## (this way is much faster than a search loop through a million serials)
function people_by_serial(p_samps::DataFrame)
    ## make a column with the row #'s, group by serial
    p_samps_by_hh = groupby(insertcols(p_samps, 1, :idx => 1:nrow(p_samps)), :SERIALNO)
    ## Ref() is a trick of the combine function (found this in the dataframes.jl docs)
    df = combine(p_samps_by_hh, :idx => Ref => :idxs)
    return Dict(df.SERIALNO .=> collect.(df.idxs))
end

## returns a vector of number employed by industry index from dataframe row r
function row_gq_employment(n::Integer, jobtype::Symbol, ind_codes::Vector{<:AbstractString}, r::DataFrameRow)::Vector{Int}
    if jobtype == :none || n < 1
        return [0 for x in ind_codes]
    else
        pref = Dict(:civ=>"civ_ind_",:mil=>"mil_ind_")
        return int.([r[pref[jobtype]*k] for k in ind_codes])
    end
end

## for evaluating results
function cbg_summary(cbg_code, cbg_dict, hh_samps, hh_idx)
    hhvec = cbg_dict[cbg_code]
    cbg_samps = empty(hh_samps)
    for x in hhvec
        push!(cbg_samps, hh_samps[hh_idx[x],:])
    end
    return combine(cbg_samps, Not(:SERIALNO) .=> x->sum(skipmissing(x)); renamecols=false)[1,:]
end


function generate_group_quarters(dConfig::Dict, cbgs::Dict{<:AbstractString, I}, 
    cbg_indexer::Indexer{I}, ind_codes::Vector{<:AbstractString}) where {I<:Integer}

    min_gq_residents::Int = get(dConfig, "min_gq_residents", 20)
    add_trait_cols::Vector{String} = get(dConfig, "additional_traits", String[])

    ## loop through gq, create individuals
    ## -- assume only 18-64 noninst have jobs
    ## -- assume children in gq don't attend public schools
    ## will need to add workers to gq, and generate a within-org network
    df_gq_cols = ["Geo", "group quarters:", "group quarters:under 18", "group quarters:18 to 64", 
        "group quarters:65 and over", "p_u18_inst", "p_18_64_inst", "p_65o_inst", "p_18_64_noninst_civil", 
        "p_18_64_noninst_mil", "commuter_p|ninst1864civ", "work_from_home_p|ninst1864civ", 
        "com_LODES_low_p|ninst1864civ", "com_LODES_high_p|ninst1864civ", "commuter_p|milGQ", 
        "work_from_home_p|milGQ", "com_LODES_low_p|milGQ", "com_LODES_high_p|milGQ"]

    df_gq = read_df("processed/group_quarters.csv"; select=df_gq_cols, types=Dict("Geo"=>String15))

    ## assume 5 gq's max per cbg:
    ## -- u18 inst, 18-64 inst, 18-64 noninst civilian, 18-64 noninst military, 65+ inst
    ## -- ignore noninst for u18 and 65+
    ## -- ignore gq with less than min_gq_size people
    gq_types = [:instu18, :inst1864, :ninst1864civ, :milGQ, :inst65o]
    assumed_ages = [15, 30, 30, 30, 75] ## ages unknown (could generate these if needed)
    job_types = [:none, :none, :civ, :mil, :none] ## assume only 18-64 noninst have jobs
    transform!(df_gq, ["group quarters:under 18","p_u18_inst"] => ((a,b)->thresh.(int.(a.*b),min_gq_residents)) => "pop_instu18")
    transform!(df_gq, ["group quarters:18 to 64","p_18_64_inst"] => ((a,b)->thresh.(int.(a.*b),min_gq_residents)) => "pop_inst1864")
    transform!(df_gq, ["group quarters:18 to 64","p_18_64_noninst_civil"] => ((a,b)->thresh.(int.(a.*b),min_gq_residents)) => "pop_ninst1864civ")
    transform!(df_gq, ["group quarters:18 to 64","p_18_64_noninst_mil"] => ((a,b)->thresh.(int.(a.*b),min_gq_residents)) => "pop_milGQ")
    transform!(df_gq, ["group quarters:65 and over","p_65o_inst"] => ((a,b)->thresh.(int.(a.*b),min_gq_residents)) => "pop_inst65o")

    ## read gq worker counts by industry, which were derived from census data
    df_civil_emp = rename(x->replace(x,"C24030:"=>"civ_ind_","C24010:"=>"civ_occ_"), 
                    read_df("processed/gq_civilian_workers.csv"; types=Dict("Geo"=>String15)))
    df_mil_emp = rename(x->replace(x,"C24030:"=>"mil_ind_","C24010:"=>"mil_occ_"), 
                    read_df("processed/gq_military_workers.csv"; types=Dict("Geo"=>String15)))

    ## not all of those are commuters -- assume p(work from home) is the same across industries
    ## randomly assign some people as wfh; do same for income category
    transform!(df_gq, ["commuter_p|ninst1864civ","work_from_home_p|ninst1864civ"] => ((a,b)->a./(a.+b)) => "commuter_p|civ_worker")
    transform!(df_gq, ["commuter_p|milGQ","work_from_home_p|milGQ"] => ((a,b)->a./(a.+b)) => "commuter_p|mil_worker")
    transform!(df_gq, ["com_LODES_high_p|ninst1864civ","com_LODES_low_p|ninst1864civ"] => ((a,b)->a./(a.+b)) => "LODES_high|civ_commuter")
    transform!(df_gq, ["com_LODES_high_p|milGQ","com_LODES_low_p|milGQ"] => ((a,b)->a./(a.+b)) => "LODES_high|mil_commuter")
    df_gq = innerjoin(df_gq, df_civil_emp, df_mil_emp; on=:Geo)

    gqs = Dict{GQkey, GQres}()
    gq_people = Dict{Pkey, PersonData}()

    for r in eachrow(df_gq)
        ## group quarters includes some cbgs without households, need to add them
        cbg_index = cbg_indexer(cbgs, r.Geo)
        ## pop of each gq type in the cbg (0 if below threshhold)
        gq_pops = [r["pop_"*string(x)] for x in gq_types]
        ## employment category counts; a vector for each gq type
        emp_stats = map((a,b)->row_gq_employment(a,b,ind_codes,r), gq_pops, job_types)
        ## for creating a unique key for each person
        p_idxs = ranges(gq_pops)

        ##
        ## assume that all residents of military quarters work at the quarters
        ## only civilians in non-inst GQs commute to jobs
        ## (this assumption is also in workplaces.jl)
        ##
        commuter_p = Dict(:instu18 => 0.0, :inst1864 => 0.0, 
                        :ninst1864civ => r["commuter_p|civ_worker"], 
                        :milGQ => 0.0, :inst65o => 0.0)

        LODES_high_p = Dict(:instu18 => 0.0, :inst1864 => 0.0, 
                        :ninst1864civ => r["LODES_high|civ_commuter"], 
                        :milGQ => r["LODES_high|mil_commuter"], :inst65o => 0.0)

        for (t_idx, t_code) in enumerate(gq_types)    
            if gq_pops[t_idx] > 0 
                ## use 0 as hh index for gq people (so looking up household will return nothing)
                pkeys = [(p_i,0,cbg_index) for p_i in p_idxs[t_idx]]
                ## create group quarter entry and add to dict
                gqs[(t_idx,cbg_index)] = GQres(t_code, pkeys)
                ## for mapping person index to employment category
                emp_idxs = cumsum(emp_stats[t_idx])
                ## create people and add to dict
                for (i,k) in enumerate(pkeys)
                    ## indices mapped to emp cats based on category counts; missing = no job
                    emp_cat = something(findfirst(x -> x >= i, emp_idxs), missing)
                    has_job = !ismissing(emp_cat)
                    is_commuter = has_job ? (rand() < commuter_p[t_code]) : false
                    ## income category, for commuters only
                    inc_cat = is_commuter ? (rand() < LODES_high_p[t_code] ? 2 : 1) : missing
                    ## employment category is only for assigning commuters to workplaces
                    emp_cat = is_commuter ? emp_cat : missing
                    ## using 0 for household index and sample#; age,sex,race,etc. unknown (could generate these if needed)
                    gq_people[k] = PersonData((0,cbg_index), 0, assumed_ages[t_idx],
                                has_job, is_commuter, emp_cat, inc_cat,
                                missing, [missing for x in add_trait_cols]...)
                end
            end
        end
    end

    ## write summary statistics for all gq's; will be used to assign ppl in gq to jobs
    df_gq_summary = DataFrame([
                    "geo" => String15[]; 
                    [string(x) => Int64[] for x in gq_types];
                    #["civ_ind_"*i => Int64[] for i in ind_codes];
                    #["mil_ind_"*i => Int64[] for i in ind_codes]
                    ["ind_"*i => Int64[] for i in ind_codes]
                    ])

    for c in df_gq.Geo
        row_summ = Dict{String,Any}("geo" => c)
        merge!(row_summ, Dict(string.(gq_types) .=> 0))
        #merge!(row_summ, Dict(["civ_ind_"*i for i in ind_codes] .=> 0))
        #merge!(row_summ, Dict(["mil_ind_"*i for i in ind_codes] .=> 0))
        merge!(row_summ, Dict(["ind_"*i for i in ind_codes] .=> 0))
        cbg_index = cbgs[c]
        for (t_idx, t_code) in enumerate(gq_types)
            gq = get(gqs, (t_idx,cbg_index), missing)
            if !ismissing(gq)
                ppl = [gq_people[k] for k in gq.residents]
                row_summ[string(gq.type)] = length(ppl)
                if gq.type == :ninst1864civ
                    #merge!(row_summ, Dict(["civ_ind_"*i for i in ind_codes] .=> counts([coalesce(x.com_cat,0) for x in ppl], 1:length(ind_codes))))
                    merge!(row_summ, Dict(["ind_"*i for i in ind_codes] .=> counts([coalesce(x.com_cat,0) for x in ppl], 1:length(ind_codes))))
                #elseif gq.type == :milGQ
                #    merge!(row_summ, Dict(["mil_ind_"*i for i in ind_codes] .=> counts([coalesce(x.com_cat,0) for x in ppl], 1:length(ind_codes))))
                end
            end
        end
        push!(df_gq_summary, row_summ)
    end
    ser_path("jlse/df_gq_summary.jlse", df_gq_summary)

    return (cbgs, gqs, gq_people)
end


function generate_people()

    dConfig = tryJSON("../src/geopops/config.json")
    additional_traits::Vector{String} = get(dConfig, "additional_traits", String[])
    wp_codes = tryJSON("processed/codes.json")
    ind_codes::Vector{String} = get(wp_codes, "ind_codes", String[])

    counties = read_counties()
    hh_idx = read_hh_serials() ## for linking household to row # in hh samps
    println("reading person samples")
    p_samps = read_psamp_df(ind_codes, additional_traits) ## for looking up person traits from sample data
    p_idx = people_by_serial(p_samps) ## for linking people in households to row #s in p_samps

    ind_colnames = Symbol.(["ind_"*k for k in ind_codes]) ## industry code columns in p_samps
    ind_col_idxs = Dict(ind_colnames .=> eachindex(ind_colnames)) ## assign an integer index to each, in order

    ## pre-compute some traits so we don't have to do it inside the loop
    ## each person has only one industry; append its code and index to each record
    transform!(p_samps, AsTable(ind_colnames) => ByRow(first_true) => "ind_code")
    transform!(p_samps, "ind_code" => ByRow(k->get(ind_col_idxs,k,missing)) => "ind_cat_idx")
    ## this determines job category for commuters
    transform!(p_samps, ["commuter", "ind_cat_idx"] => 
                        ByRow((a,b)-> a ? b : missing) => 
                        "com_cat")

    ## same for income categories (but these already exclude non-commuters)
    income_colnames = [:com_LODES_low, :com_LODES_high]
    income_col_idxs = Dict(:com_LODES_low => 1, :com_LODES_high => 2)
    transform!(p_samps, AsTable(income_colnames) => ByRow(first_true) => "income_code")
    transform!(p_samps, "income_code" => ByRow(k->get(income_col_idxs,k,missing)) => "com_inc")

    add_trait_cols = Symbol.(additional_traits)

    cbgs = Dict{String15, CBGkey}() ## assign an index to each cbg processed
    cbg_indexer = Indexer{CBGkey}()
    households = Dict{Hkey, Household}() ## create a unique hh id for each hh
    people = Dict{Pkey, PersonData}() ## create unique person id for each person
    
    println("generating people")
    for c in counties
        println("county ",c)
        cbg_hhs = dser_path("jlse/CO/hh"*c*".jlse");

        for (cbg_code, hh_vec) in cbg_hhs ## vector of households in each cbg
            cbg_i = cbg_indexer(cbgs, cbg_code)
            for (hh_i, hh_serial) in enumerate(hh_vec)
                hh_key = (hh_i, cbg_i)
                p_vec = p_idx[hh_serial] ## person sample indices in each household
                for (p_i, r) in enumerate(p_vec) ## create each person from data in sample df
                    people[(p_i,hh_i,cbg_i)] = PersonData(
                        hh_key, 
                        r, 
                        p_samps[r,:AGEP], 
                        p_samps[r,:has_job], 
                        p_samps[r,:commuter], 
                        p_samps[r,:com_cat],
                        p_samps[r,:com_inc],
                        p_samps[r,:sch_grade],
                        [p_samps[r,x] for x in add_trait_cols]...)
                end
                households[hh_key] = Household(hh_idx[hh_serial], [(i,hh_i,cbg_i) for i in eachindex(p_vec)])
            end
        end    
    end

    println("generating group quarters")
    cbgs, gqs, gq_people = generate_group_quarters(dConfig, cbgs, cbg_indexer, ind_codes)
    people = merge(gq_people, people)

    ## write to files for next step
    println("writing people to file")
    ser_path("jlse/cbg_idxs.jlse", Dict([v=>k for (k,v) in cbgs]))
    ser_path("jlse/hh.jlse", households)
    ser_path("jlse/gqs.jlse", gqs)
    ser_path("jlse/people.jlse", people)

    return nothing
end

#=
Copyright 2023 Alexander Tulchinsky

This file is part of Greasypop.

Greasypop is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Greasypop is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License along with Greasypop. If not, see <https://www.gnu.org/licenses/>.
=#

using Random
using SparseArrays
using ProportionalFitting
using Logging
#using Statistics

include("utils.jl")
include("fileutils.jl")

## splits n into a vector that sums to n
##   by drawing from a lognormal dist (mu, sigma)
##   receives and updates a vector of unused draws
function split_lognormal!(n::Integer, mu::Float64, sigma::Float64, draws::Vector{I}) where I<:Integer
    sizes = Vector{Int64}()
    ## don't bother generating if less than:
    while n > 2
        ## try to use an unused draw
        i = findfirst(x->x<=n, draws)
        if isnothing(i)
            sz = ceil(Int64,rlogn(mu,sigma)) ## round up to avoid 0's
            ## if it's too big, save for later (otherwise we're cheating at the distribution)
            while sz > n 
                push!(draws,sz)
                sz = ceil(Int64,rlogn(mu,sigma)) ## round up
            end
        else
            sz = popat!(draws,i)
        end
        push!(sizes, sz)
        n -= sz
    end
    ## append remaining, if any
    if n > 0
        push!(sizes,n)
    end
    return sizes
end

## reads people generated in households.jl
## returns {residence geo => list of worker keys} for each category
function group_commuters_by_origin(cat_codes::Vector{S}) where {S<:AbstractString}
    ## within each category, group by cbg, randomize order
    cbgs = dser_path("jlse/cbg_idxs.jlse")

    ## only commuters are assigned to workplaces
    ## dataframe provides fast grouping
    df = DataFrame([(id=k[1], hh=k[2], cbg=k[3], income=v.com_inc, category=v.com_cat) 
                    for (k,v) in filterv(x->x.commuter, dser_path("jlse/people.jlse"))])
    df_grouped = groupby(df, [:category, :cbg])

    ## a dict for each category, containing a dict of cbg => list of workers
    ## each worker is identified by (id, household, cbg, income category)
    ##  -- the latter is for easier generating of income-assortative workplace networks
    worker_keys = Dict(kc => 
                        Dict(ko => Vector{Tuple{fieldtypes(Pkey)...,eltype(df.income)}}()
                        for ko in values(cbgs))
                    for kc in cat_codes)

    ## fill the dict from dataframe
    ## shuffle each list of workers so they can be assigned to workplaces in order
    for gk in keys(df_grouped)
        cat_code, cbg_code = cat_codes[gk[:category]], cbgs[gk[:cbg]]
        worker_keys[cat_code][cbg_code] = shuffle( [(r.id,r.hh,r.cbg,r.income) for r in eachrow(df_grouped[gk])] )
    end
    
    return worker_keys
end

## for generating data-less "dummy" people who commute from outside the synth pop
function dummy_gen_fn()
    dummy_idx = 0
    ## each dummy needs to be provided an income code for assortative network construction
    f = function(origin::AbstractString, inc_code::Integer)
        dummy_idx += 1
        ## diagnostics (dummy should only be created when origin is "outside")
        d_err = origin == "outside" ? 0 : 1
        ## dummies have no household or home cbg
        return (dummy_idx,0,0,UInt8(inc_code)), d_err
    end
    return f
end

## household sample summaries has # of commuters for every sample household
## files in CO/ have a list of households by geo code
## return a dict of {residence geo => # commuters} for each category in cat_codes
function read_workers_by_cat(cat_codes::Vector{<:AbstractString}, counties::Vector{<:AbstractString})
    cat_cols = ["com_ind_"*k for k in cat_codes]
    hh_samps = read_df("processed/hh_samples.csv"; select=[["SERIALNO","NP","com_LODES_low","com_LODES_high"]; cat_cols], types=Dict("SERIALNO"=>String15))
    hh_idx = Dict(hh_samps.SERIALNO .=> eachindex(hh_samps.SERIALNO))
    
    workers_by_cat_x_ori = Dict(k => Dict{String15,Int64}() for k in cat_codes)
    for co in counties
        cbg_dict = dser_path("jlse/CO/hh"*co*".jlse") ## read households generated for cbgs in county
        for (ori, hhvec) in cbg_dict ## for each cbg in county, look up # workers in hh sample summaries
            for (cat_code, cat_col) in zip(cat_codes, cat_cols) ## sum each category across households
                workers_by_cat_x_ori[cat_code][ori] = sum(skipmissing(hh_samps[[hh_idx[x] for x in hhvec], cat_col]))
            end
        end
    end
    return workers_by_cat_x_ori
end

## summary generated in households.jl has # of workers in each GQ
##
## assume that all residents of military quarters work at the quarters
## only civilians in non-inst GQs commute to jobs
## (this assumption is also in households.jl)
##
function read_gq_workers_by_cat(cat_codes::Vector{<:AbstractString})
    gq_df = dser_path("jlse/df_gq_summary.jlse")
    cat_cols = ["ind_"*k for k in cat_codes]
    
    gq_by_cat_x_ori = Dict(k => Dict{String15,Int64}() for k in cat_codes)
    for r in eachrow(gq_df)
        for (cat_code, cat_col) in zip(cat_codes, cat_cols)
            gq_by_cat_x_ori[cat_code][r.geo] = r[cat_col]
        end
    end
    return gq_by_cat_x_ori
end

## read commute matrix for category k
## data is in sparse format, so m and n are needed to determine dimensions
function read_od_matrix(k::AbstractString, m::Integer, n::Integer)
    df = read_df("processed/od_"*k*".csv.gz"; types=Dict("origin"=>UInt32,"dest"=>UInt32,"p"=>Float32))
    return sparse(df.origin, df.dest, df.p, m, n)
end

## counts of workers commuting from outside the synth area
function read_outside_origins(cat_codes::Vector{S}) where {S<:AbstractString}
    tmp_dict = let df = read_df("processed/work_cats_live_outside.csv"); Dict(df[!,1] .=> df[!,2]); end
    return Dict(k => round(Int,tmp_dict["C24030:"*k]) for k in cat_codes)
end

## calculate origin-destination counts for each category in cat_codes
## write to file (don't need them all in mem at once)
## also keep hh and gq separate for now, in case they need to be treated differently
function calc_od_counts(cat_codes::Vector{<:AbstractString}, counties::Vector{<:AbstractString})

    ## these vectors map row and col idxs in the od matrices to geo codes in the population
    origin_labels = let df = read_df("processed/od_rows_origins.csv"); df.origin; end
    dest_labels = let df = read_df("processed/od_columns_dests.csv"); df.dest; end
    n_rows = length(origin_labels)
    n_cols = length(dest_labels)
    origin_idx = Dict(origin_labels .=> eachindex(origin_labels))

    ## read # workers from hh sample summary, workers living in gq's from gq summary
    ## these are dicts of geo code => count for each category in cat_codes
    println("reading worker counts")
    hhw_by_cat_x_ori = read_workers_by_cat(cat_codes,counties)
    gqw_by_cat_x_ori = read_gq_workers_by_cat(cat_codes)

    println("# workers living in synth area = ", sum(values(reduce(mergewith(+), values(hhw_by_cat_x_ori)))) + 
                                                sum(values(reduce(mergewith(+), values(gqw_by_cat_x_ori)))))

    ## need # workers with origin "outside"; append to hh workers dict
    outside_by_cat = read_outside_origins(cat_codes)
    for k in cat_codes
        hhw_by_cat_x_ori[k]["outside"] = outside_by_cat[k]
    end

    println("# workers living outside = ", sum(values(outside_by_cat)))

    ## multiply workers by od matrix
    println("calculating origin-destination counts")
    test_tot = 0
    for k in cat_codes
        println("  for category ",k)
        M = read_od_matrix(k, n_rows, n_cols);
        hh_counts = SparseMatrixCSC{UInt32, UInt32}(spzeros(n_rows, n_cols))
        gq_counts = SparseMatrixCSC{UInt32, UInt32}(spzeros(n_rows, n_cols))
        for (code, rownum) in origin_idx
            hh_counts[rownum,:] = lrRound(M[rownum,:] .*  get(hhw_by_cat_x_ori[k],code,0))
            gq_counts[rownum,:] = lrRound(M[rownum,:] .*  get(gqw_by_cat_x_ori[k],code,0))
        end
        ser_path("jlse/od_counts_"*k*".jlse",(hh_counts, gq_counts))
        test_tot += sum(hh_counts) + sum(gq_counts)
    end

    println("# workers assigned to destinations = ", test_tot)
    return (origin_labels, dest_labels)
end


## employer size stats by county
function read_county_stats()
    cols = Dict("county"=>String7,"mu_ln"=>Float64,"sigma_ln"=>Float64)
    county_stats = read_df("processed/work_sizes.csv"; select=collect(keys(cols)), types=cols)
    return Dict(county_stats.county .=> zip(county_stats.mu_ln, county_stats.sigma_ln))
end

## n people working in schools and school locations
function read_school_info()
    ## find the closest cbg for each school
    distmat = read_df("processed/cbg_sch_distmat.csv"; types=Dict("GEOID"=>String15))
    closest_cbg = Dict(x => distmat[argmin(distmat[!,x]),"GEOID"] for x in String15.(names(distmat)[2:end]))
    
    ## number of teachers by school
    sch_cols = Dict("NCESSCH"=>String15,"TEACHERS"=>Int64,"STUDENTS"=>Int64)
    schools = read_df("processed/schools.csv"; select=collect(keys(sch_cols)), types=sch_cols)
    sch_n_teachers = Dict(schools.NCESSCH .=> schools.TEACHERS)

    return (sch_n_teachers, closest_cbg)
end

## n people working in gqs and gq locations
function read_gq_info()
    ## find cbg where each gq is located
    gqs = dser_path("jlse/gqs.jlse")
    cbgs = dser_path("jlse/cbg_idxs.jlse")
    gq_cbgs = Dict(k => cbgs[k[2]] for k in keys(gqs))
    ## inst qg's: assume 1 workers per 10 residents; non-inst, 1 per 50? mininum 2?
    dConfig = tryJSON("config.json")
    r_i::Float64 = float(get(dConfig, "inst_res_per_worker", 10))
    r_ni::Float64 = float(get(dConfig, "noninst_res_per_worker", 50))
    e_min::Int = get(dConfig, "min_gq_workers", 2)
    ni_types = Set([:milGQ, :ninst1864civ])
    
    gq_n_emps = Dict(k => 
                max(e_min, ceil(Int64, v.type in ni_types ? length(v.residents)/r_ni : length(v.residents)/r_i)) 
                for (k,v) in gqs)

    return (gq_n_emps, gq_cbgs)
end

## filter work destinations by geo code and boolean function
## dest_idx is dict of geo code => index
## return indices
function filter_dests(f, geo::Sa, dest_idx::Dict{Sb, I}) where {I<:Integer,Sa<:AbstractString,Sb<:AbstractString}
    return collect(values(filter( ((k,v),) -> (startswith(k,geo) && f(v)) , dest_idx)))
end

## commute origins for people working in schools and gq's
## modifies count_matrix
function pull_inst_workers!(count_matrix::Matrix{<:Integer}, 
    dest_idx::Dict{<:AbstractString, <:Integer}, origin_labels::Vector{Ko},
    workers_by_key::Dict{Ki, <:Integer}, loc_by_key::Dict{Ki, <:AbstractString}) where {Ki<:Any,Ko<:AbstractString}

    ## for each institution, pull n workers who have a suitable work _destination_
    #test = Dict(k=>[] for k in keys(workers_by_key))
    inst_emp_origins = Dict{Ki,Vector{Ko}}()
    for (inst_id, n) in workers_by_key
        cbg = loc_by_key[inst_id]
        ## find destination(s) with enough workers; try closest cbg first, then wider areas
        ## limit to same county
        ## employment numbers may not agree exactly with commute numbers
        ## also, official employment location in commute data may not be the inst's actual location
        ## draw as many workers as possible going to the actual location
        ## then make up the remainder from nearby locations
        ## this way, commuters are coming from approximately the right area
        geo_areas = [cbg,cbg[1:11],cbg[1:9],cbg[1:7],cbg[1:5]]
        ## column sums change on each loop
        colsums = vec(sum(count_matrix;dims=1))
        ## for each geo area, a list of destination indices (columns) with > 0 workers:
        dest_lists = [filter_dests(i->(colsums[i]>0), geo, dest_idx) for geo in geo_areas]
        ## shuffle each list, but preserve the geo area order:
        avail_cols = unique(reduce(vcat, map(shuffle, dest_lists)))
        ## draw from columns until enough workers
        o_idxs = Int[]
        for col in avail_cols
            draw_n = min(colsums[col], n)
            #push!(test[inst_id], (col,draw_n))
            ## pass a view of the column so the original matrix gets modified
            append!(o_idxs, drawCounts!(view(count_matrix,:,col), draw_n))
            n = n - draw_n
            if n < 1
                break
            end
        end
        if n > 0
            println("warning: inst $inst_id loc $cbg short by $n workers")
        end

        inst_emp_origins[inst_id] = origin_labels[o_idxs]
    end
    return inst_emp_origins
end

## group by destination, split into workplaces, assign origins
## modifies count_matrix in place
## returns a dict of workplace ids => employee cbgs
function generate_workplaces!(count_matrix::Matrix{<:Integer}, dest_idx::Dict{<:AbstractString, <:Integer}, 
    origin_labels::Vector{Ko}, county_stats::Dict{<:AbstractString, Tuple{Float64, Float64}},
    draws_by_county::Dict{<:AbstractString, Vector{I}},
    cat_idx::Integer) where {Ko<:AbstractString,I<:Integer}

    work_origins = Dict{WRKkey, Vector{Ko}}()
    for (co,draws) in draws_by_county
        (mu,sigma) = county_stats[co]
        ## work destinations in the county we just read the stats for
        dests = filterk(k->k[1:5]==co, dest_idx)
        for (dest_code, col) in dests
            n = sum(count_matrix[:,col]) ## number of workers in the dest
            if n > 0
                sizes = split_lognormal!(n,mu,sigma,draws)
                for (work_i, emp_size) in enumerate(sizes)
                    ## get rand sample of origins; pass a view so original matrix is modified
                    o_idxs = drawCounts!(view(count_matrix,:,col), emp_size)
                    ## create workplace and assign origins sampled
                    work_origins[(work_i, cat_idx, dest_code)] = origin_labels[o_idxs]
                end
            end
        end
        #println(draws)
    end
    return work_origins
end

## make a separate work destination for each person working outside the synth area
##  (no need to try to group them, as they have no work network anyway)
function generate_outside_workplaces(work_outside::Dict{K, <:Integer}, cat_idx::Integer) where {K<:Any}
    return Dict([WRKkey((i, cat_idx, "outside")) for i in 1:sum(values(work_outside))]  
        .=> map(x->Vector{K}([x]), reduce(vcat, [fill(k, v) for (k, v) in work_outside])))
end

## assigns people in workers_by_origin to employers in emp_origins
## modifies cidx_by_origin so that it can be called with several emp_origins on the same pop
## creates "dummies" -- workers from outside that don't exist in people data
## returns a dict of employer id => vector of worker ids, and some diagnostics
function assign_workers!(emp_origins::Dict{T,Vector{K}}, workers_by_origin::Dict{K, Vector{W}}, 
    cidx_by_origin::Dict{K, I}, dummy_fn::F) where {T<:Any,K<:Any,W<:Any,I<:Integer,F<:Function}

    n_by_origin = Dict(k => length(v) for (k,v) in workers_by_origin)
    ## p high income workers, for generating dummies
    p_LODES_high = sum(count.(x->x[4]==2, values(workers_by_origin))) / sum(values(n_by_origin))

    ## initialize empty lists
    workers = Dict(est_id=>Vector{W}() for est_id in keys(emp_origins))
    dummies = Vector{W}() ## keep track of dummies created

    missing_origin = 0
    ran_out = Dict{K,Int64}()
    for (e_id, origin_vec) in emp_origins
        for origin_key in origin_vec
            ## if the origin is not in cidx, it's outside the synth area and a dummy must be created
            if haskey(cidx_by_origin, origin_key)
                i = cidx_by_origin[origin_key] += 1 ## this doesn't look like it should be allowed, but it is lol
                if i > n_by_origin[origin_key]
                    ran_out[origin_key] = get!(ran_out, origin_key, 0) + 1 ## this shouldn't happen
                else
                    push!(workers[e_id], (workers_by_origin[origin_key][i]))
                end
            else
                ## create dummy
                inc_code = rand() < p_LODES_high ? 2 : 1
                dum::W, d_err::Int = dummy_fn(origin_key, inc_code)
                push!(dummies, dum)
                push!(workers[e_id], dum)
                ## diagnostics (all origins except "outside" should have been in cidx)
                missing_origin += d_err
            end
        end
    end
    return (workers, dummies, missing_origin, ran_out)
end


function generate_jobs_and_workers()

    wp_codes = tryJSON("processed/codes.json")
    ind_codes::Vector{String} = get(wp_codes, "ind_codes", String[])
    ind_idxs = Dict(ind_codes .=> eachindex(ind_codes))
    ser_path("jlse/wp_cat_codes.jlse",ind_idxs)
    counties = let cbgs = dser_path("jlse/cbg_idxs.jlse"); unique(map(x->x[1:5], values(cbgs))); end

    println("reading commuters in synth pop")
    worker_keys = group_commuters_by_origin(ind_codes)
    ## if origin is outside the synth area, will generate a dummy instead of assigning a resident
    dummy_fn = dummy_gen_fn()

    ## calculate origin-destination counts and save to files
    ## "labels" vectors map row and col idxs in the od matrices to geo codes in the population
    ## workplaces will be generated based on the od matrices
    ## then connected to people/locations in the synth pop using the label indices
    origin_labels, dest_labels = calc_od_counts(ind_codes, counties)
    ser_path("jlse/od_labels.jlse",(origin_labels,dest_labels))

    dest_idx = Dict(dest_labels .=> eachindex(dest_labels)) ## for easy lookup

    ## mean and sd of ln(workplace size) for each county
    county_stats = read_county_stats()
    ## adjust stats
    ##  slightly overproduces large employers compared to CBP stats
    ##  (but unlisted employers should probably skew large)
    stats2 = deepcopy(county_stats)
    for (k,v) in stats2
        stats2[k] = (v[1], v[2]+0.1)
    end

    ## save employer size draws by county, to make best use of county-level stats
    draws_by_county = Dict(k => Vector{Int}() for k in counties)

    ## special treatment for these:
    school_teacher_category = "EDU"
    gq_employee_category = "ADM_MIL"
    ## could make gq workers more accurate by handling each type of gq separately
    ##   but there are not very many of them, and _most_ will be prison workers (ind #92)
    (sch_n_emps, sch_cbgs) = read_school_info()
    (gq_n_emps, gq_cbgs) = read_gq_info()

    ## data structures for collecting results
    sch_workers = Dict()
    gq_workers = Dict()
    company_workers = Dict()
    outside_workers = Dict()
    dummies = Dict()
    missing_origins = Dict()
    ran_out = Dict()

    ## do the following by category
    for ckey in ind_codes

        println("generating workplaces for category "*ckey)

        ## id's of synth pop residents to assign to workplaces
        workers_by_origin = worker_keys[ckey]
        ## instead of removing workers as they're assigned, just keep pointers to the first available worker
        cidx_by_origin = Dict(keys(workers_by_origin) .=> 0)

        ## origin-destination matrix for current category
        hh_sparse, gq_sparse = dser_path("jlse/od_counts_"*ckey*".jlse");
        od_counts = Matrix(hh_sparse+gq_sparse)
        ## pull off the last column (work destination outside the synth area)
        work_outside_counts = od_counts[:,end]
        od_counts = od_counts[:,1:end-1]
        ## by origin code, # people working outside the synth area
        work_outside = Dict(origin_labels .=> work_outside_counts)

        ## check totals (before modifying od_counts)
        n_jobs_in_synth_area = sum(od_counts)
        n_jobs_outside_area = sum(work_outside_counts)
        n_jobs_od_total = n_jobs_in_synth_area + n_jobs_outside_area
        n_com_from_synth_area = sum(od_counts[1:end-1,:]) + sum(work_outside_counts)
        n_com_from_outside = sum(od_counts[end,:])

        ## pull out workers for schools and gqs for each destination (except "outside")
        ##   (assumes workers from out of state can work in public schools)
        ##   samples worker origins in proportion to counts 
        ##   currently does not consider worker income, age, etc.
        if ckey == school_teacher_category
            sch_emp_origins = pull_inst_workers!(od_counts, dest_idx, origin_labels, sch_n_emps, sch_cbgs)
            (sch_workers[ckey], dummies["sch"*ckey], missing_origins["sch"*ckey], ran_out["sch"*ckey]) = assign_workers!(
                sch_emp_origins, workers_by_origin, cidx_by_origin, dummy_fn)
            n_sch_jobs_generated = sum(length.(values(sch_emp_origins)))
            n_sch_workers_assigned = sum(length.(values(sch_workers[ckey])))
        else
            n_sch_jobs_generated = 0
            n_sch_workers_assigned = 0
        end

        if ckey == gq_employee_category
            gq_emp_origins = pull_inst_workers!(od_counts, dest_idx, origin_labels, gq_n_emps, gq_cbgs)
            (gq_workers[ckey], dummies["gq"*ckey], missing_origins["gq"*ckey], ran_out["gq"*ckey]) = assign_workers!(
                gq_emp_origins, workers_by_origin, cidx_by_origin, dummy_fn)
            n_gq_jobs_generated = sum(length.(values(gq_emp_origins)))
            n_gq_workers_assigned = sum(length.(values(gq_workers[ckey])))
        else
            n_gq_jobs_generated = 0
            n_gq_workers_assigned = 0
        end

        ## create workplaces for remaining workers for each destination (except "outside")
        ## and assign workers to those
        work_origins = generate_workplaces!(od_counts, dest_idx, origin_labels, stats2, draws_by_county, ind_idxs[ckey])
        (company_workers[ckey], dummies[ckey], missing_origins[ckey], ran_out[ckey]) = assign_workers!(
            work_origins, workers_by_origin, cidx_by_origin, dummy_fn);

        ## check results
        n_unused_draws = sum(length.(values(draws_by_county)))
        n_jobs_generated_within = sum(length.(values(work_origins))) + n_sch_jobs_generated + n_gq_jobs_generated
        n_workers_living_within = sum(length.(values(workers_by_origin)))
        println("  # jobs within synth area = $n_jobs_in_synth_area outside = $n_jobs_outside_area total = $n_jobs_od_total")
        println("  # commuting from outside = $n_com_from_outside resident workers needed = $n_com_from_synth_area")
        println("  # jobs generated = $n_jobs_generated_within workers in synth area = $n_workers_living_within")
        println("  (# unused wp size draws = $n_unused_draws)")
        println("  # workers assigned to jobs = " ,sum(length.(values(company_workers[ckey]))) +  n_gq_workers_assigned +  n_sch_workers_assigned)

        ## don't forget to assign people to work_outside origins
        n_by_origin = Dict(k => length(v) for (k,v) in workers_by_origin)
        unused = Dict(k => max(0,(v - cidx_by_origin[k])) for (k,v) in n_by_origin)
        println("  # remaining workers = ", sum(values(unused)))

        (outside_workers[ckey], _, missing_origins["out"*ckey], ran_out["out"*ckey]) = assign_workers!(
            generate_outside_workplaces(work_outside, ind_idxs[ckey]), workers_by_origin, cidx_by_origin, dummy_fn);
        ## check results
        println("  # jobs created outside synth area = ", sum(length.(values(outside_workers[ckey]))))
    end

    ## merge categories, save to file for next step
    println("writing results to file")
    suffix = ""
    ser_path("jlse/work_dummies"*suffix*".jlse", reduce(vcat, values(dummies)))
    ser_path("jlse/sch_workers"*suffix*".jlse",reduce(vecmerge, values(sch_workers)))
    ser_path("jlse/gq_workers"*suffix*".jlse",reduce(vecmerge, values(gq_workers)))
    ser_path("jlse/company_workers"*suffix*".jlse",reduce(vecmerge, values(company_workers)))
    ser_path("jlse/outside_workers"*suffix*".jlse",reduce(vecmerge, values(outside_workers)))

    ## check results
    #reduce(+, values(missing_origins))
    #reduce(mergewith(+), values(ran_out))
    company_worker_counts = length.(values(reduce(vecmerge, values(company_workers))))
    sch_worker_counts = length.(values(reduce(vecmerge, values(sch_workers))))
    gq_worker_counts = length.(values(reduce(vecmerge, values(gq_workers))))
    outside_worker_counts = length.(values(reduce(vecmerge, values(outside_workers))))
    origin_worker_counts = length.(values(reduce(vecmerge, values(worker_keys))))
    n_workers_from_outside = sum(values(read_outside_origins(ind_codes)))
    println("")
    println("# workers living in synth pop = ", sum(origin_worker_counts))
    println("# workers commuting from outside = ",  n_workers_from_outside)
    println("total workers = ", sum(origin_worker_counts) + n_workers_from_outside)
    println("# company employees = ", sum(company_worker_counts))
    println("# school employees = ", sum(sch_worker_counts), " expected ",sum(values(sch_n_emps)))
    println("# gq employees = ", sum(gq_worker_counts), " expected ",sum(values(gq_n_emps)))
    println("# working outside synth pop = ", sum(outside_worker_counts))
    println("total assigned to jobs = ", sum(company_worker_counts)+sum(sch_worker_counts)+sum(gq_worker_counts)+sum(outside_worker_counts))
    println("")
    println("generated establishment sizes (other than schools and group quarters):")
    println("size<5: ",count(x->x<5, company_worker_counts))
    println("4<size<10: ",count(x->(4<x<10), company_worker_counts))
    println("9<size<20: ",count(x->(9<x<20), company_worker_counts))
    println("19<size<50: ",count(x->(19<x<50), company_worker_counts))
    println("49<size<100: ",count(x->(49<x<100), company_worker_counts))
    println("99<size<250: ",count(x->(99<x<250), company_worker_counts))
    println("249<size<500: ",count(x->(249<x<500), company_worker_counts))
    println("499<size<1000: ",count(x->(499<x<1000), company_worker_counts))
    println("999<size<1500: ",count(x->(999<x<1500), company_worker_counts))
    println("1499<size<2500: ",count(x->(1499<x<2500), company_worker_counts))
    println("2499<size<5000: ",count(x->(2499<x<5000), company_worker_counts))
    println("size>4999: ",count(x->x>4999, company_worker_counts))

    return nothing
end


## generate commute matrices by industry using IPF
## based on census and LODES data
## needed before workplaces can be generated
function generate_commute_matrices()
    println("generating commute matrices")
    Logging.disable_logging(Logging.Info)

    ind_codes::Vector{String} = let wp_codes = tryJSON("processed/codes.json"); get(wp_codes, "ind_codes", String[]); end;

    ## n of workers by industry at each origin, from census data (assumed true)
    (total_by_ori, m_ind_ori) = let io_df = read_df("processed/work_io_sums.csv"; types=Dict("Geo"=>String15));
        (sum(Matrix(io_df[!,2:end]);dims=2), 
        permutedims( rowRound(Matrix(io_df[!,2:end])) , (2,1) ));
    end;

    ## n workers commuting from each origin to each dest; census counts * proprtions from LODES OD data
    (origin_idxs, dest_idxs, m_dest_ori) = let od_df = read_df("processed/work_od_prop.csv"; types=Dict("Geo"=>String15))
        (od_df[!,:Geo], names(od_df)[2:end],
        sparse(permutedims( rowRound(total_by_ori .* Matrix(od_df[!,2:end])) , (2,1) )));
    end;

    ## p ind at each dest, estimated from WAC data
    m_ind_dest_p = let id_est_df = read_df("processed/work_id_est_sums.csv"; types=Dict(1=>String15));
        m_ind_dest = permutedims( Matrix(id_est_df[!,2:end]), (2,1) );
        m_ind_dest ./ sum(m_ind_dest; dims=1); ## p ind at each dest
    end;

    ## for storing results
    res_iod = [spzeros(Float32, length(origin_idxs), length(dest_idxs)) for i in ind_codes];

    for (o,x) in enumerate(origin_idxs)
        o % 100 == 0 && println(o, "/", length(origin_idxs))

        ## row sum targets = workers in each industry at this origin
        ind_margin = m_ind_ori[:,o]
        ## column sum targets = workers commuting to each destination from this origin
        ## only need to consider non-zero columns
        d_idxs, d_margin = findnz(m_dest_ori[:,o])
        if isempty(d_idxs)
            ## no commute data exists for this origin; have to make something up
            ## most likely, nobody lives there; show a warning if they do
            sum(ind_margin) > 0 && println("warning: no commute data for ",x,", ",sum(ind_margin)," workers affected")
            ## anyway, set destination equal to origin, or to a random dest preferably in same county
            new_m = fill(1.0,(length(ind_margin),1))
            d_idxs = Int[something(findfirst(x->x==origin_idxs[o], dest_idxs),
                                    rand(first_nonempty([findall(x->x[1:5]==origin_idxs[o][1:5], dest_idxs)
                                                        ,findall(x->true, dest_idxs)])))]
        else
            ## initial matrix based on p each industry at each destination, while preserving origin-destination counts
            ## IPF will make it also preserve by-industry counts
            ## this can be done separately for each origin; overall totals by destination and by industry will be correct
            preserve_od_vals = (d_margin' .* m_ind_dest_p[:, d_idxs]);
            ## do IPF; handles zeros poorly, so replace with some small value
            init_m = max.(preserve_od_vals,0.00001);
            fac = ipf(init_m, [ind_margin, d_margin], maxiter=500, tol=1e-6);
            ## result = proportion going to each destination (by industry)
            new_m = Array(fac) .* init_m 
            new_margin = sum(new_m; dims=2) ## will be same as ind_margin if IPF converged
            new_m = new_m ./ new_margin
            ## for industries with 0 workers at this location, still need some kind of commute data
            ## assume they follow overall proportions from OD counts
            new_m[isapprox.(vec(new_margin), 0.0), :] .= d_margin' / sum(d_margin)
        end
        ## store results
        for (i,c) in enumerate(ind_codes)
            res_iod[i][o,d_idxs] .= new_m[i,:]
        end
    end

    println("writing commute matrices")
    write_df("processed/od_rows_origins.csv", DataFrame(:idx=>eachindex(origin_idxs),:origin=>origin_idxs))
    write_df("processed/od_columns_dests.csv", DataFrame(:idx=>eachindex(dest_idxs),:dest=>dest_idxs))
    for (i,k) in enumerate(ind_codes)
        write_df("processed/od_"*k*".csv.gz", res_iod[i], [:origin,:dest,:p]; compress=true)
    end

    return nothing
end

#=
Copyright 2023 Alexander Tulchinsky

This file is part of Greasypop.

Greasypop is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Greasypop is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License along with Greasypop. If not, see <https://www.gnu.org/licenses/>.
=#

using SparseArrays
include("fileutils.jl")

## Matrix Market native exchange format for sparse matrices
##  https://math.nist.gov/MatrixMarket/formats.html#MMformat
using MatrixMarket

mkpath("pop_export")

println("household adjacency matrix")

m = dser_path("jlse/adj_mat_hh.jlse")
MatrixMarket.mmwrite(abspath("pop_export/adj_upper_triang_hh.mtx"), m)

d = nothing
GC.gc()

println("non-household adjacency matrix")

m = dser_path("jlse/adj_mat_non_hh.jlse")
MatrixMarket.mmwrite(abspath("pop_export/adj_upper_triang_non_hh.mtx"), m)

d = nothing
GC.gc()

println("workplace only adjacency matrix")

m = dser_path("jlse/adj_mat_wp.jlse")
MatrixMarket.mmwrite(abspath("pop_export/adj_upper_triang_wp.mtx"), m)

d = nothing
GC.gc()

println("school only adjacency matrix")

m = dser_path("jlse/adj_mat_sch.jlse")
MatrixMarket.mmwrite(abspath("pop_export/adj_upper_triang_sch.mtx"), m)

d = nothing
GC.gc()

println("groups quarters only adjacency matrix")

m = dser_path("jlse/adj_mat_gq.jlse")
MatrixMarket.mmwrite(abspath("pop_export/adj_upper_triang_gq.mtx"), m)

d = nothing
GC.gc()

println("index keys")

d = dser_path("jlse/adj_mat_keys.jlse")
df = DataFrame([(index_one=i, index_zero=i-1, p_id=Int(v[1]), hh_id=Int(v[2]), cbg_id=Int(v[3])) for (i,v) in enumerate(d)])
write_df("pop_export/adj_mat_keys.csv",df)

## indices of people commuting fron outside the synth pop area
##  these have no household connections
d = dser_path("jlse/adj_dummy_keys.jlse")
df = DataFrame(sort([
            (index_one=Int64(k), index_zero=Int64(k)-1, p_id=Int(v[1]), hh_id=Int(v[2]), cbg_id=Int(v[3]))
            for (k,v) in d
            ], by=x->x.index_one))
write_df("pop_export/adj_dummy_keys.csv",df)

## indices of people working outside the synth pop area
##  these have no workplace connections
d = dser_path("jlse/adj_out_workers.jlse")
df = DataFrame(sort([
            (index_one=Int64(k), index_zero=Int64(k)-1, p_id=Int(v[1]), hh_id=Int(v[2]), cbg_id=Int(v[3]))
            for (k,v) in d
            ], by=x->x.index_one))
write_df("pop_export/adj_out_workers.csv",df)

println("done")

#=
Copyright 2023 Alexander Tulchinsky

This file is part of Greasypop.

Greasypop is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Greasypop is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License along with Greasypop. If not, see <https://www.gnu.org/licenses/>.
=#

using CSV
using DataFrames
using SparseArrays
using Serialization
using JSON

function tryJSON(f::AbstractString)::Dict{String,Any}
    try
        return JSON.parsefile(abspath(f))
    catch e
        return Dict{String,Any}()
    end
end

function dser_path(f::AbstractString)
    #println("reading ", f)
    return deserialize(abspath(f))
end

function ser_path(f::AbstractString,obj::Any)
    #println("writing ", f)
    serialize(abspath(f), obj)
    return nothing
end

function read_df(f::AbstractString; kwargs...)
    return CSV.read(abspath(f), DataFrame; kwargs...)
end

function write_df(f::AbstractString, df; kwargs...)
    CSV.write(abspath(f), df; kwargs...)
end

## creates a sparse dataframe from a sparse matrix
spDataFrame(m::SparseMatrixCSC, labels::Union{Vector,Symbol}=:auto) = DataFrame(collect(findnz(m)), labels)

function write_df(f::AbstractString, m::SparseMatrixCSC, labels::Union{Vector,Symbol}=:auto; kwargs...)
    CSV.write(abspath(f), spDataFrame(m, labels); kwargs...)
end
